
#ifndef _OOS_SDK_C_BUFFER_H_
#define _OOS_SDK_C_BUFFER_H_

#ifdef __cplusplus
extern "C" {
#endif

#include <stdlib.h>
#include <stdint.h>
#include "oos_define.h"

typedef struct buffer_s buffer;
typedef struct buffer_s buffer_t;
struct buffer_s {
    int status_code;
    char status_msg[50];
    char request_id[128];
    char error_msg[2048];
    char host_id[128];
    char etag[64];

    char* header;
    size_t header_used;
    size_t header_size;
    oos_table_t* headers;

    char* body;
    size_t body_used;
    size_t body_size;

    char* content;
    int64_t content_length;
    size_t content_used;
    size_t content_size;
};


extern buffer* buffer_init(oos_pool_t *p);
extern void buffer_free(buffer* b);

extern int buffer_header_prepare_append(buffer* b, size_t size);
extern int buffer_header_append_string_len(buffer* b, const char* s, size_t len);

extern int buffer_body_prepare_append(buffer* b, size_t size);
extern int buffer_body_append_string_len(buffer* b, const char* s, size_t len);

extern int buffer_content_prepare_append(buffer* b, size_t size);
extern int buffer_content_append_len(buffer* b, const char* s, size_t len);

#ifdef __cplusplus
}
#endif
#endif  // _KS3_SDK_C_BUFFER_H_
