#include "oos_api.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <mxml.h>
#include <inttypes.h>



char ACCESS_KEY[128] = "your ak";
char SECRET_KEY[128] = "your sk";
char HOST_NAME[512] = "oos-cn.ctyunapi.cn";
char BUCKET_NAME[512] = "your bucket name";
char FILE_PATH[128] = "upload file path";

void list_all_bucket_test(){
    oos_pool_t *p = NULL;
    request_options_t *options = NULL;
    oos_status_t *status = NULL;
    oos_list_bucket_t *buckets = NULL;
    oos_pool_create(&p, NULL);
    options = (request_options_t *)oos_pcalloc(p, sizeof(request_options_t));
    
    options->pool = p;
    oos_str_set(options->pool,  &options->access_key, ACCESS_KEY);
    oos_str_set(options->pool,  &options->secret_key, SECRET_KEY);
    oos_str_set(options->pool,  &options->endpoint, HOST_NAME);
    options->is_v4 = OOS_TRUE;
    options->is_sign_payload = OOS_TRUE;
    oos_table_t* resp_headers = oos_table_make(options->pool, 1);
    status = oos_list_buckets(options, &buckets, &resp_headers);
    printf("service code %d\n", status->code);


     struct list_head *pos; 
    list_for_each(pos, buckets->root){
    oos_list_bucket_content_t* temp = list_entry(pos,struct oos_list_bucket_content_t,node);
        printf("0000000 id %s\n", temp->name.data);
    }   
    printf("owner_id:%s\n", buckets->owner_id.data); 
    printf("display_name:%s\n", buckets->owner_DisplayName.data);

    oos_pool_destroy(p);
}

void list_objects_test() {
	oos_pool_t *p = NULL;
	request_options_t *options = NULL;
	oos_status_t *status = NULL;
	oos_list_object_t *objects = NULL;
	oos_pool_create(&p, NULL);
	options = (request_options_t *)oos_pcalloc(p, sizeof(request_options_t));
	options->pool = p;
	oos_table_t* resp_headers = oos_table_make(options->pool, 1);
	oos_str_set(options->pool, &options->access_key, ACCESS_KEY);
	oos_str_set(options->pool, &options->secret_key, SECRET_KEY);
	oos_str_set(options->pool, &options->endpoint, HOST_NAME);
	options->is_v4 = OOS_TRUE;
	options->is_sign_payload = OOS_TRUE;;
	status = oos_list_objects(options, BUCKET_NAME, NULL, NULL, NULL, "100", &objects, &resp_headers);
	printf("service code %d\n", status->code);
	printf("service code %s\n", status->error_msg);
	oos_list_object_content_t *tmp = NULL;
	list_for_each_entry(tmp, objects->root, node)
	{
		printf("name: %s, etag: %s\n", tmp->key.data, tmp->eTag.data);
	}

	struct list_head *pos;

	if (objects) {
		printf("delimiter:%s", objects->delimiter.data);
		printf("prefix:%s", objects->prefix.data);
		printf("marker:%s", objects->marker.data);
		printf("maxKeys:%s", objects->maxKeys.data);
		printf("isTruncated:%s", objects->isTruncated.data);
		printf("name:%s", objects->name.data);
		printf("nextMarker:%s", objects->nextMarker.data);
	}


    list_for_each(pos, objects->prefix_root){
     oos_list_object_common_prefix_t* temp = list_entry(pos,struct oos_list_object_common_prefix_t,node);
     printf("0000000 id %s\n", temp->prefix.data);
    }
    oos_pool_destroy(p);
}

void create_bucket_test(request_options_t *options,oos_status_t *status){
    oos_table_t* resp_headers = oos_table_make(options->pool, 1);

    // make location config
    struct location_configuration_t* config;
    config = oos_pcalloc(options->pool, sizeof(*config));
    oos_str_set(options->pool,  &config->medadata_location,"ShenZhen");
    config->data_location_type = LOCAL;
    config->data_schedule_strategy = ALLOWED;

    // add multiple data location to locationg config
    INIT_LIST_HEAD(&config->data_location_list.node);
    add_list_string_node(options, "ShenZhen", &config->data_location_list.node);

    status = oos_create_bucket(options, BUCKET_NAME, BUCKET_TYPE_PRIVATE, config, &resp_headers);
    printf("service code %d\n", status->code);
}

void head_bucket_test(request_options_t *options,oos_status_t *status){
    oos_table_t* resp_headers = oos_table_make(options->pool, 1);
    status = oos_head_bucket(options,"sdk-no",&resp_headers);
    printf("service code %d\n", status->code);
}

void delete_bucket_test(request_options_t *options,oos_status_t *status){
    oos_table_t* resp_headers = oos_table_make(options->pool, 1);
    status = oos_delete_bucket(options,"wangxingshan",&resp_headers);
    printf("service code %d\n", status->code);
}

void head_object_test(request_options_t *options,oos_status_t *status){
    oos_table_t* resp_headers = oos_table_make(options->pool, 1);
	oos_table_t* req_header = oos_table_make(options->pool, 1);
	oos_table_set(req_header, "Range", "bytes=1-30000");
    oos_table_set(req_header, "If-Match", "fc3ff98e8c6a0d3087d515c0473f8677");
    oos_table_set(req_header, "If-None-Match", "fc3ff98e8c6a0d3087d515c0473f8677");
    oos_table_set(req_header, "If-Modified-Since", "2019-05-01T09:12:43.083Z");
    oos_table_set(req_header, "If-Unmodified-Since", "2019-05-01T09:12:43.083Z");
    status = oos_head_object(options,BUCKET_NAME,"your_object", req_header, &resp_headers);
    printf("service code %d\n", status->code);
}

void delete_object_test(request_options_t *options,oos_status_t *status){
    oos_table_t* resp_headers = oos_table_make(options->pool, 1);
    status = oos_delete_object(options,BUCKET_NAME,"testxj/",&resp_headers);
    printf("service code %d\n", status->code);
}

void delete_multiple_object_test(request_options_t *options,oos_status_t *status){
    oos_table_t* resp_headers = oos_table_make(options->pool, 1);

    delete_multiple_list_t* list = oos_pcalloc(options->pool, sizeof(*list));
    INIT_LIST_HEAD(&list->delete_list.node);

    add_list_object_node_pool(options->pool, "test1.txt", &list->delete_list);
    add_list_object_node_pool(options->pool, "test11.txt", &list->delete_list);
    add_list_object_node_pool(options->pool, "test12.txt", &list->delete_list);

    status = oos_delete_multiple_object(options,BUCKET_NAME,list,OOS_TRUE,&resp_headers);
    printf("service code %d\n", status->code);
    if(status->code < 300){
        char result[2048] = {"\0"};
        list_delete_node_t* tmp;
        if(!list_empty(&list->delete_list.node)){
            list_for_each_entry(tmp, &list->delete_list.node, node)
            {
                char object_result[64] = {"\0"};
                strcat(object_result, tmp->object_key.data);
                strcat(object_result, ":");
                strcat(object_result, tmp->result.data);
                strcat(result, object_result);
            }
        }
        printf("==============result:%s", result);
    }
}

void copy_object_test(request_options_t *options,oos_status_t *status){
    copy_object_result_t* result ;
    oos_table_t* req_headers = oos_table_make(options->pool, 1);
    oos_table_t* resp_headers = oos_table_make(options->pool, 1);
   // oos_table_set(req_headers, "x-amz-meta-media_key1", "value1");
   // oos_table_set(req_headers, "x-amz-meta-media_key2", "value2");
   // oos_table_set(req_headers, "x-amz-copy-source-if-modified-since", "Fri, 28 Apr 2019 07:58:00 GMT");
   // oos_table_set(req_headers, "x-amz-copy-source-if-unmodified-since", "Mon, 13 May 2019 07:58:00 GMT"); 

    oos_table_set(req_headers, "x-amz-copy-source-if-none-match", "c84c314e2d5696bad88669cf517f6852");
    status = oos_copy_object(options,BUCKET_NAME,"abc/888.jpg",BUCKET_NAME,"your_object2",&result,req_headers, &resp_headers);
    printf("service code %d\n", status->code);
    printf("service msg %s\n", status->error_msg);
    printf("etag %s\n", result->etag.data);
}

void put_bucket_lifecycle_test(request_options_t *options, oos_status_t *status){
    lifecycle_configuration_t* config;
    config = oos_pcalloc(options->pool, sizeof(*config));
    oos_str_set(options->pool,  &config->ruleid,"111");
    oos_str_set(options->pool,  &config->prefix,"www1/");
    oos_str_set(options->pool,  &config->status,"Enabled");
    //oos_str_set(options->pool,  &config->date,"2011");
    config->days=10;
    lifecycle_configuration_t* config1;
    config1 = oos_pcalloc(options->pool, sizeof(*config));
    oos_str_set(options->pool,  &config1->ruleid,"222");
    oos_str_set(options->pool,  &config1->prefix,"www2/");
    oos_str_set(options->pool,  &config1->status,"Disabled");
    oos_str_set(options->pool,  &config1->date,"2019-07-30T00:00:00.000Z");
    //config->days=100;
    lifecycle_configuration_t* config2;
    config2 = oos_pcalloc(options->pool, sizeof(*config));
    oos_str_set(options->pool,  &config2->ruleid,"333");
    oos_str_set(options->pool,  &config2->prefix,"www3/");
    oos_str_set(options->pool,  &config2->status,"Disabled");
    //oos_str_set(options->pool,  &config1->date,"2011");
    config2->days=100;

    lifecycle_configuration_t configs[3];
    // memcpy((char *)&configs[0],(char *)&config,sizeof(config));
    memcpy((char *)&configs[0],(char *)config,sizeof(*config));
    memcpy((char *)&configs[1],(char *)config1,sizeof(*config));
    memcpy((char *)&configs[2],(char *)config2,sizeof(*config));
    oos_table_t* resp_headers = oos_table_make(options->pool, 1);

    status = oos_put_bucket_lifecycle(options,BUCKET_NAME,configs,3,&resp_headers);
    printf("service code %d\n", status->code);
    printf("err_msg %s\n", status->error_msg);
}

void get_bucket_lifecycle_test(request_options_t *options, oos_status_t *status){
    lifecycle_configuration_t* config=NULL; 
    oos_table_t* resp_headers = oos_table_make(options->pool, 1);
    status = oos_get_bucket_lifecycle(options, BUCKET_NAME, &config,&resp_headers);
    printf("service code %d\n", status->code);

    if(config){
        struct list_head *pos;
        list_for_each(pos, &config->node){
            lifecycle_configuration_t* tmp = list_entry(pos,struct lifecycle_configuration_t,node);
            printf("ruleid: %s, prefix: %s status:%s day:%d date:%s\n", tmp->ruleid.data, tmp->prefix.data, tmp->status.data, tmp->days, tmp->date.data);
        }
    }

}
void delete_bucket_lifecycle_test(request_options_t *options,oos_status_t *status){
    oos_table_t* resp_headers = oos_table_make(options->pool, 1);
    status = oos_delete_bucket_lifecycle(options, BUCKET_NAME, &resp_headers);
    printf("service code %d\n", status->code);
}

void get_bucket_location_test(request_options_t *options, oos_status_t *status){
    location_configuration_t* config=NULL;
    oos_table_t* resp_headers = oos_table_make(options->pool, 1);
    status = oos_get_bucket_location(options, "sdk-no", &config, &resp_headers);
    printf("service code %d\n", status->code);


    char result[2048] = {"\0"};
    sprintf(result, "meta location:%s\n, data location type:%d \n schedule Strategy:%d\n",
            config->medadata_location.data, config->data_location_type, config->data_schedule_strategy);

    list_string_node_t* tmp;
    list_for_each_entry(tmp, &config->data_location_list.node, node)
    {
        char location[64] = {"\0"};
        strncpy(location, tmp->text.data, tmp->text.len);
        strcat(location, "\n");
      strcat(result, location);
    }
    printf("==============result:%s", result);
}

void get_bucket_acl_test(request_options_t *options, oos_status_t *status){
    acl_configuration_t* config=NULL;
    oos_table_t* resp_headers = oos_table_make(options->pool, 1);
    status = oos_get_bucket_acl(options, "test11", &config, &resp_headers);
    printf("service code %d\n", status->code);


    char result[2048] = {"\0"};

    if(config){
        if(config->id.len > 0){
            strcat(result, "owner Id:");
            strcat(result, config->id.data);
        }
        if(config->display_name.len > 0){
            strcat(result, "owner DisplayName:");
            strcat(result, config->display_name.data);
        }
         strcat(result, "\n");

        acl_grant_info* tmp;
        list_for_each_entry(tmp, &config->grant_list.node, node)
        {
            // Grantee URI
            if(tmp->grantee_uri.len > 0){
                strcat(result, "Grantee URI:");
                strcat(result, tmp->grantee_uri.data);
                strcat(result, " ");
            }
            // Permission
            if(tmp->permission.len > 0){
                strcat(result, "Permission:");
                strcat(result, tmp->permission.data);
                strcat(result, "\n");
            }
        }
    }


    printf("==============result:%s", result);
}


void get_regions_test(request_options_t *options, oos_status_t *status){
    region_configuration_t* config=NULL;
    oos_table_t* resp_headers = oos_table_make(options->pool, 1);
    status = oos_get_regions(options, &config, &resp_headers);
    printf("service code %d\n", status->code);


    char result[2048] = {"\0"};

    if(config){
        strcat(result, "dataRegions:\n");
        list_string_node_t* tmp;
        list_for_each_entry(tmp, &config->data_location_list.node, node)
        {
            char location[64] = {"\0"};
            strncpy(location, tmp->text.data, tmp->text.len);
            strcat(location, "\n");
          strcat(result, location);
        }
        strcat(result, "MetadataRegions:\n");

        list_for_each_entry(tmp, &config->meta_location_list.node, node)
        {
            char location[64] = {"\0"};
            strncpy(location, tmp->text.data, tmp->text.len);
            strcat(location, "\n");
          strcat(result, location);
        }
    }

    printf("==============result:%s", result);
}

void put_bucket_accelerate_test(request_options_t *options,oos_status_t *status){
    oos_table_t* resp_headers = oos_table_make(options->pool, 1);

    // make location config
    struct accelerate_configuration_t* config;
    config = oos_pcalloc(options->pool, sizeof(*config));
    // status
    config->status = ENABLED;

    // add multiple ip to white lists
    INIT_LIST_HEAD(&config->ip_white_list.node);

    add_list_string_node(options, "222.222.222.222", &config->ip_white_list.node);
    add_list_string_node(options, "111.111.111.111", &config->ip_white_list.node);

    status = oos_put_bucket_accelerate(options,"sdktest", config, &resp_headers);
    printf("service code %d\n", status->code);
}

void get_bucket_accerlerate_test(request_options_t *options, oos_status_t *status){
    accelerate_configuration_t* config=NULL;
    oos_table_t* resp_headers = oos_table_make(options->pool, 1);
    status = oos_get_bucket_accelerate(options, BUCKET_NAME, &config,&resp_headers);
    printf("service code %d\n", status->code);

    char result[2048] = {"\0"};
    sprintf(result, "accerlerate: status:%d\n", config->status);
    list_string_node_t* tmp;
    list_for_each_entry(tmp, &config->ip_white_list.node, node)
    {
        char ip[64] = {"\0"};
        strncpy(ip, tmp->text.data, tmp->text.len);
        strcat(ip, "\n");
      strcat(result, ip);
    }


    printf("==============result:%s", result);
}

void put_bucket_cors_test(request_options_t *options,oos_status_t *status){
    oos_table_t* resp_headers = oos_table_make(options->pool, 1);

    // make location config
    struct cors_configuration_t* config;
    config = oos_pcalloc(options->pool, sizeof(*config));
    INIT_LIST_HEAD(&config->cors_rule_list.node);

    // add cors rule1
    list_cors_rule_node_t* cors_rule_node;
    cors_rule_node = oos_pcalloc(options->pool, sizeof(*cors_rule_node));
    INIT_LIST_HEAD(&cors_rule_node->node);
    INIT_LIST_HEAD(&cors_rule_node->allowed_header_list.node);
    INIT_LIST_HEAD(&cors_rule_node->allowed_method_list.node);
    INIT_LIST_HEAD(&cors_rule_node->allowed_origin_list.node);
    INIT_LIST_HEAD(&cors_rule_node->expose_header_list.node);

    // add id
    oos_str_set(options->pool,  &cors_rule_node->id,"111");

    // add allowed orign1 orign2
    add_list_string_node(options, "www.test1.com", &cors_rule_node->allowed_origin_list);
    add_list_string_node(options, "www.test2.com", &cors_rule_node->allowed_origin_list);

    // add allowed method1 method2
    add_list_string_node(options, "PUT", &cors_rule_node->allowed_method_list);
    add_list_string_node(options, "GET", &cors_rule_node->allowed_method_list);

    // add allowed headers1 headers2
    add_list_string_node(options, "x-amz*", &cors_rule_node->allowed_header_list);
    add_list_string_node(options, "*", &cors_rule_node->allowed_header_list);

    // add expose_header1 expose_header2
    add_list_string_node(options, "test1", &cors_rule_node->expose_header_list);
    add_list_string_node(options, "test2", &cors_rule_node->expose_header_list);

    cors_rule_node->maxage_seconds = 10;
    list_add_tail(&cors_rule_node->node, &config->cors_rule_list.node);

    // add cors rule2
    cors_rule_node = oos_pcalloc(options->pool, sizeof(*cors_rule_node));
    INIT_LIST_HEAD(&cors_rule_node->node);
    INIT_LIST_HEAD(&cors_rule_node->allowed_header_list.node);
    INIT_LIST_HEAD(&cors_rule_node->allowed_method_list.node);
    INIT_LIST_HEAD(&cors_rule_node->allowed_origin_list.node);
    INIT_LIST_HEAD(&cors_rule_node->expose_header_list.node);

    // add id
    oos_str_set(options->pool,  &cors_rule_node->id,"222");

    // add allowed orign1 orign2
    add_list_string_node(options, "www.test1.com", &cors_rule_node->allowed_origin_list);
    add_list_string_node(options, "www.test2.com", &cors_rule_node->allowed_origin_list);

    // add allowed method1 method2
    add_list_string_node(options, "PUT", &cors_rule_node->allowed_method_list);
    add_list_string_node(options, "GET", &cors_rule_node->allowed_method_list);

    // add allowed headers1 headers2
    add_list_string_node(options, "x-amz*", &cors_rule_node->allowed_header_list);
    add_list_string_node(options, "*", &cors_rule_node->allowed_header_list);

    // add expose_header1 expose_header2
    add_list_string_node(options, "test1", &cors_rule_node->expose_header_list);
    add_list_string_node(options, "test2", &cors_rule_node->expose_header_list);

    cors_rule_node->maxage_seconds = 10;

    list_add_tail(&cors_rule_node->node, &config->cors_rule_list.node);

    status = oos_put_bucket_cors(options,"sdk-test-1", config, &resp_headers);
    printf("service code %d\n", status->code);


}

void get_bucket_cors_test(request_options_t *options, oos_status_t *status){
    cors_configuration_t* config=NULL;
    oos_table_t* resp_headers = oos_table_make(options->pool, 1);
    status = oos_get_bucket_cors(options, "sdk-test-1", &config,&resp_headers);
    printf("service code %d\n", status->code);

    char result[20480+1] = {"\0"};
    strcat(result, "cors result:\n");

    if(config){
        list_cors_rule_node_t* cors_rule_node_for;
        list_for_each_entry(cors_rule_node_for, &config->cors_rule_list.node, node)
        {
            list_cors_rule_node_t* cors_rule_node = cors_rule_node_for;

            // ID
            strcat(result, "rule ID:");
            if(cors_rule_node->id.len > 0){
                strcat(result, cors_rule_node->id.data);
            }

            // MaxageSecond
            strcat(result, " MaxageSecond:");
            if(cors_rule_node->maxage_seconds > 0){
                char max_age[64] = {"\0"};
                sprintf(max_age, "%d\n", cors_rule_node->maxage_seconds);
                strcat(result, max_age);
            }

            // AllowedOrign
            list_string_node_t* tmp_node;
            list_for_each_entry(tmp_node, &cors_rule_node->allowed_origin_list.node, node){
                char tmp[128+1] = {"\0"};
                sprintf(tmp, "AllowedOrign:%s\n", tmp_node->text.data);
                strcat(result, tmp);
            }
            // AllowedMethod
            tmp_node = NULL;
            list_for_each_entry(tmp_node, &cors_rule_node->allowed_method_list.node, node){
                char tmp[128+1] = {"\0"};
                sprintf(tmp, "AllowedMethod:%s\n", tmp_node->text.data);
                strcat(result, tmp);
            }
            // AllowedHeader
            tmp_node = NULL;
            list_for_each_entry(tmp_node, &cors_rule_node->allowed_header_list.node, node) {
                char tmp[128+1] = {"\0"};
                sprintf(tmp, "AllowedHeader:%s\n", tmp_node->text.data);
                strcat(result, tmp);
            }
            //ExposeHeader
            tmp_node = NULL;
            list_for_each_entry(tmp_node, &cors_rule_node->expose_header_list.node, node){
                char tmp[128+1] = {"\0"};
                sprintf(tmp, "ExposeHeader:%s\n", tmp_node->text.data);
                strcat(result, tmp);
            }

        }
    }


    printf("==============result:%s", result);
}

void delete_bucket_cors_test(request_options_t *options,oos_status_t *status){
    oos_table_t* resp_headers = oos_table_make(options->pool, 1);
    status = oos_delete_bucket_cors(options,"sdk-test-1",&resp_headers);
    printf("service code %d\n", status->code);
}



void put_bucket_website_test(request_options_t *options,oos_status_t *status){
    website_configuration_t* configweb;
    configweb = oos_pcalloc(options->pool,sizeof(*configweb));
    oos_table_t* resp_headers = oos_table_make(options->pool, 1);
    oos_str_set(options->pool,  &configweb->suffix,"test.suffix.index.html");
    oos_str_set(options->pool,  &configweb->key,"test.key.index.html");
    status = oos_put_bucket_website(options,BUCKET_NAME,configweb,&resp_headers);
    printf("service code %d\n", status->code);   
}

void get_bucket_website_test(request_options_t *options,oos_status_t *status){
    website_configuration_t* configweb;
    oos_table_t* resp_headers = oos_table_make(options->pool, 1);
    status = oos_get_bucket_website(options,BUCKET_NAME,&configweb, &resp_headers);
    printf("service code %d\n", status->code);   
    printf("website prefix %s\n", configweb->suffix.data);
}

void delete_bucket_website_test(request_options_t *options,oos_status_t *status){
    oos_table_t* resp_headers = oos_table_make(options->pool, 1);
    status = oos_delete_bucket_website(options,BUCKET_NAME,&resp_headers);
    printf("service code %d\n", status->code); 
}

void put_bucket_logging_test(request_options_t *options,oos_status_t *status){
    logging_configuration_t* configlog;
    configlog = oos_pcalloc(options->pool,sizeof(*configlog));
    oos_str_set(options->pool,  &configlog->targetBucket,"test111");
    oos_str_set(options->pool,  &configlog->targetPrefix,"");
    // oos_str_set(options->pool,  &configlog->triggerTargetBucket,"triggerTargetBucket");
    // oos_str_set(options->pool,  &configlog->triggerTargetPrefix,"triggerTargetPrefix/");
    // oos_str_set(options->pool,  &configlog->triggerSourceBucket,"triggerSourceBucket");
    // oos_str_set(options->pool,  &configlog->triggerSourcePrefix,"triggerSourcePrefix/");
    oos_table_t* resp_headers = oos_table_make(options->pool, 1);
    status = oos_put_bucket_logging(options,BUCKET_NAME,configlog,&resp_headers);
    printf("service code %d\n", status->code);   
}

void get_bucket_logging_test(request_options_t *options,oos_status_t *status){
    logging_configuration_t* config;
    oos_table_t* resp_headers = oos_table_make(options->pool, 1);
    status = oos_get_bucket_logging(options,BUCKET_NAME,&config,&resp_headers);
    printf("service code %d\n", status->code);       
    printf("config targetPrefix  %s\n", config->targetBucket.data);       
}

void put_bucket_policy_test(request_options_t *options,oos_status_t *status){
    oos_table_t* resp_headers = oos_table_make(options->pool, 1);
    char text[] = "{\"Version\":\"2012-10-17\",\"Id\":\"http referer policy example\",\"Statement\":[{\"Sid\":\"Allow get requests referred by www.mysite.com \", \"Effect\":\"Allow\",\"Principal\":{ \"AWS\": [\"*\"] }, \"Action\":\"s3:*\", \"Resource\":\"arn:aws:s3:::sdk-c-test1/*\", \"Condition\":{\"StringLike\":{\"aws:Referer\":[\"http://www.mysite.com/*\"]} }} ]}";
    status = oos_put_bucket_policy(options, "sdk-no",text,&resp_headers);
    printf("service code %d\n", status->code);    
}

void get_bucket_policy_test(request_options_t *options,oos_status_t *status){
    char* policy_text= oos_pcalloc(options->pool,2048);
    oos_table_t* resp_headers = oos_table_make(options->pool, 1);
    status = oos_get_bucket_policy(options, "sdk-no", policy_text,&resp_headers);
    printf("policy text %s\n", policy_text);
    printf("service code %d\n", status->code);    
}

void delete_bucket_policy_test(request_options_t *options,oos_status_t *status){
    oos_table_t* resp_headers = oos_table_make(options->pool, 1);
    status = oos_delete_bucket_policy(options,BUCKET_NAME,&resp_headers);
    printf("service code %d\n", status->code);       
}


void create_access_key_test(request_options_t *options,oos_status_t *status){
    oos_list_access_key_member_t* key; 
    oos_table_t* resp_headers = oos_table_make(options->pool, 1);
    //status = oos_create_ctyun_access_key(options, &key, &resp_headers);
    status = oos_create_ctyun_access_key(options, &key, &resp_headers);
    printf("status %p\n", status);
    printf("service code %d\n", status->code);
    printf("999999999999 %s\n", key->userName.data);
}

void delete_ctyun_access_key_test(request_options_t *options,oos_status_t *status){
    oos_table_t* resp_headers = oos_table_make(options->pool, 1);
    status = oos_ctyun_delete_access_key(options,"58d54bba474e236fe6ad",&resp_headers);
    printf("service code %d\n", status->code);
}

void update_ctyun_access_key_test(request_options_t *options,oos_status_t *status){
    oos_table_t* resp_headers = oos_table_make(options->pool, 1);
    status = oos_ctyun_update_access_key(options,"58d54bba474e236fe6ad","Active","false",&resp_headers);
    printf("service code %d\n", status->code); 
}

void list_ctyun_access_key_test(request_options_t *options,oos_status_t *status){
    oos_list_access_key_t* key; 
    oos_table_t* resp_headers = oos_table_make(options->pool, 1);
    status = oos_ctyun_list_access_key(options,0,NULL,&key,&resp_headers);
     printf("status %p\n", status);
    printf("service code %d\n", status->code);
    printf("access key userName %s\n", key->userName.data);
    // list_for_each(pos, &config->node){
    //     trigger_configuration_t* tmp = list_entry(pos,struct trigger_configuration_t,node);
    //     printf("triggerName: %s, isDefault: %s\n", tmp->triggerName.data, tmp->isDefault.data);
    // }
}


void put_file_object_test(request_options_t *options,oos_status_t *status){
    oos_table_t* medadata = oos_table_make(options->pool, 1);
    oos_table_t* resp_headers = oos_table_make(options->pool, 1);
    oos_table_set(medadata, "x-amz-meta-media_key1", "value1");
    oos_table_set(medadata, "x-amz-meta-media_key2", "value2");
    status = oos_put_object_from_file(options,BUCKET_NAME,"your_object_file", FILE_PATH,medadata,&resp_headers);
    printf("service code %d\n", status->code); 
}

void get_file_object_test(request_options_t *options,oos_status_t *status){
    char* file_path ="./test.txt";
    int pos = 0;
    const oos_array_header_t *tarr;
    const oos_table_entry_t *telts;
    oos_table_t* medadata = NULL;
    oos_table_t* resp_headers = oos_table_make(options->pool, 1);
    oos_table_t* req_header = oos_table_make(options->pool, 1);
    oos_table_set(req_header, "Range", "1-3");
    status = oos_get_object_to_file_ex(options,BUCKET_NAME,"your_object", req_header, file_path, &medadata,&resp_headers);
    if (medadata) {
        tarr = oos_table_elts(medadata);
        telts = (oos_table_entry_t*)tarr->elts;
        for (pos = 0; pos < tarr->nelts; ++pos) {
                printf("%s:%s\n",telts[pos].key, telts[pos].val);
        }
    }

    printf("service code %d\n", status->code); 
}


void put_buf_object_test(request_options_t *options,oos_status_t *status){
    // status = put_buf_object(options,BUCKET_NAME,"wxs/test4.xml","hello world!",sizeof("hello world!"));
    oos_table_t* medadata = oos_table_make(options->pool, 1);
    //oos_table_set(medadata, "x-amz-meta-media_key1", "value1");
    oos_table_set(medadata, "x-amz-storage-class", "REDUCED_REDUNDANCY");
    oos_table_set(medadata, "x-ctyun-data-location", "type=Specified,location=ShenZhen,QingDao,scheduleStrategy=Allowed");

    oos_table_t* resp_headers = oos_table_make(options->pool, 1);
    status = oos_put_object_from_buffer(options,BUCKET_NAME,"testxj/your_object","hello world!",strlen("hello world!"),medadata,&resp_headers);
    printf("service code %d\n", status->code); 
    printf("service msg %s\n", status->error_msg);
    int pos = 0;
    const oos_array_header_t *tarr;
    const oos_table_entry_t *telts;
    if (resp_headers) {
        tarr = oos_table_elts(resp_headers);
        telts = (oos_table_entry_t*)tarr->elts;
        for (pos = 0; pos < tarr->nelts; ++pos) {
                printf("--!- %s:%s\n",telts[pos].key, telts[pos].val);
        }
    }

}

void genrate_object_presignedurl_test(request_options_t *options,oos_status_t *status){
    // status = put_buf_object(options,BUCKET_NAME,"wxs/test4.xml","hello world!",sizeof("hello world!"));

    oos_table_t* resp_headers = oos_table_make(options->pool, 1);
    char* url_result;
    int expires = 3600;
    status = oos_object_generate_presigned_url(options,BUCKET_NAME,"your_object", expires, &resp_headers, &url_result);
    printf("service code %d\n", status->code);
    printf("result url%s\n", url_result);
    printf("service msg %s\n", status->error_msg);
    int pos = 0;
    const oos_array_header_t *tarr;
    const oos_table_entry_t *telts;
    if (resp_headers) {
        tarr = oos_table_elts(resp_headers);
        telts = (oos_table_entry_t*)tarr->elts;
        for (pos = 0; pos < tarr->nelts; ++pos) {
                printf("--!- %s:%s\n",telts[pos].key, telts[pos].val);
        }
    }
}

///Users/wangxingshan/temp/123.txt
void init_multipart_upload_test(request_options_t *options,oos_status_t *status){
    initiate_multipart_upload_result_t* result;
    oos_table_t* resp_headers = oos_table_make(options->pool, 1);
    oos_table_t* medadata = oos_table_make(options->pool, 1);
    oos_table_set(medadata, "x-amz-meta-media_key1", "value");
    oos_table_set(medadata, "x-amz-meta-media_key2", "value2");
    oos_table_set(medadata, "x-ctyun-data-location", "type=Local,location=QingDao,scheduleStrategy=NotAllowed");
    status = oos_init_multipart_upload(options, BUCKET_NAME,"copypartdst.txt", &result, medadata,&resp_headers);
    printf("service code %d\n", status->code);
    printf("upload id %s\n", result->uploadId.data);
}

void list_multipart_uploads_test(request_options_t *options,oos_status_t *status){
    oos_list_multipart_uploads_t* list_upload;
    oos_table_t* resp_headers = oos_table_make(options->pool, 1);
    status = oos_list_multipart_uploads(options, BUCKET_NAME, NULL, NULL, "100", "copypartdst.txt", "1556614443423352648", &list_upload,&resp_headers);
    printf("service code %d\n", status->code);
    struct list_head *pos; 

	if (list_upload) {
		printf("bucket:%s", list_upload->bucket.data);
		printf("isTruncated:%s", list_upload ->isTruncated.data);
		printf("keyMarker:%s", list_upload->keyMarker.data);
		printf("maxUploads:%s", list_upload->maxUploads.data);
		printf("nextKeyMarker:%s", list_upload->nextKeyMarker.data);
		printf("nextUploadIdMarker:%%", list_upload->nextUploadIdMarker.data);
		printf("uploadIdMarker:%s", list_upload->uploadIdMarker.data);
	}

    list_for_each(pos, list_upload->root){
    oos_list_multipart_uploads_content_t* temp = list_entry(pos,struct oos_list_multipart_uploads_content_t,node);
        printf("0000000 id %s\n", temp->uploadId.data);
    }
}

void abort_multipart_upload_test(request_options_t *options,oos_status_t *status){
    oos_table_t* resp_headers = oos_table_make(options->pool, 1);
    status = oos_abort_multipart_upload(options,BUCKET_NAME,"copypartdst.txt","1551262046276000902",&resp_headers);
    printf("service code %d\n", status->code);
}

void upload_part_test(request_options_t *options, oos_status_t *status){
    FILE* file = NULL;
    size_t file_size;
    size_t part_size = 300*1024;
    oos_string_t* etag = (oos_string_t*)oos_pcalloc(options->pool, sizeof(*etag));
    oos_table_t* resp_headers = oos_table_make(options->pool, 1);

    file = fopen("/home/xiaojun/OOS-SDK/oos-c-sdk/oos-c-sdk/oos_test", "rb");
    if (file == NULL) {
        fprintf(stderr, "open file %s failed : %m\n", "sdsfdsdfsd");
        return ;
    }

    fseek(file, 0, SEEK_END);
    file_size = ftell(file);
    fseek(file, 0, SEEK_SET);
    char* buff; 
    buff = (char*)oos_pcalloc(options->pool, file_size);
    int a = fread(buff, 1,part_size, file);
    status = oos_upload_part_from_buffer(options, "sdktest", "copypartdst.txt","1551928898624318892",1,buff,a,etag,&resp_headers);
    printf("====== fist part complete : etag - %s\n", etag->data);

    //第二片
    oos_str_set(options->pool,  &options->endpoint, HOST_NAME);
    resp_headers = oos_table_make(options->pool, 1);
    fseek(file, part_size, SEEK_SET);
    buff = (char*)oos_pcalloc(options->pool, file_size);
    int n = fread(buff, 1, (file_size-part_size), file);
    oos_str_set(options->pool,  &options->endpoint, HOST_NAME);
    status = oos_upload_part_from_buffer(options, "sdktest", "copypartdst.txt","1551928898624318892",2,buff,n,etag,&resp_headers);
    printf("====== etag%s\n", etag->data);
}

void copy_part_test(request_options_t *options, oos_status_t *status){


    char InitUploadID[100] = {"\0"};
    strcpy(InitUploadID, "1556614500227444338");

    oos_string_t* etag1 = (oos_string_t*)oos_pcalloc(options->pool, sizeof(*etag1));
    oos_table_t* req_headers1 = oos_table_make(options->pool, 1);
    oos_table_t* resp_headers1 = oos_table_make(options->pool, 1);
    //oos_table_set(req_headers1, "x-amz-copy-source-if-modified-since", "Fri, 28 Apr 2019 07:58:00 GMT");
    //oos_table_set(req_headers1, "x-amz-copy-source-if-unmodified-since", "Fri, 28 Apr 2019 07:58:00 GMT");
    //oos_table_set(req_headers1, "x-amz-copy-source-if-match", "fc3ff98e8c6a0d3087d515c0473f8677====");
    oos_table_set(req_headers1, "x-amz-copy-source-if-none-match", "fc3ff98e8c6a0d3087d515c0473f8677======");
    status = oos_copy_part(options,BUCKET_NAME,"copypartdst.txt",InitUploadID, 1, BUCKET_NAME, "your_object2",  req_headers1, etag1, &resp_headers1);

    printf("====== fist part complete : etag1 - %s\n", etag1->data);

    //第二个object

    //oos_string_t* etag2 = (oos_string_t*)oos_pcalloc(options->pool, sizeof(*etag2));
    //oos_table_t* req_headers2 = oos_table_make(options->pool, 1);
    //oos_table_t* resp_headers2 = oos_table_make(options->pool, 1);

    //status = oos_copy_part(options,BUCKET_NAME,"copypartdst.txt",InitUploadID, 2, BUCKET_NAME, "test2.txt",  req_headers2, etag2, &resp_headers2);
    //printf("====== second part complete : etag2 - %s\n", etag2->data);

}

void complete_multipart_upload_test(request_options_t *options,oos_status_t *status){
    part_etags* tag1;
    part_etags tags[2];
    tag1 = oos_pcalloc(options->pool,sizeof(*tag1));
    oos_table_t* resp_headers = oos_table_make(options->pool, 1);
    tag1->partnumber =1;
    oos_str_set(options->pool,  &tag1->etag,"3548f18c30a663de5cc2d66c1298659a");
    memcpy((char *)&tags[0],(char *)tag1,sizeof(*tag1));

    part_etags* tag2;
    tag2 = oos_pcalloc(options->pool,sizeof(*tag2));
    tag2->partnumber =2;
    oos_str_set(options->pool,  &tag2->etag,"ad1d5617cac970ec72f3dd2faf961788");
    memcpy((char *)&tags[1],(char *)tag2,sizeof(*tag2));

    status = oos_complete_multipart_upload(options,BUCKET_NAME,"copypartdst.txt","1551434486424033575",tags,2,&resp_headers);
    printf("service code %d\n", status->code);
    
}

void list_parts_test(request_options_t *options,oos_status_t *status){
    part_listing_t* listing; 
    oos_table_t* resp_headers = oos_table_make(options->pool, 1);
    status = oos_list_parts(options,"test111","mutiobj.txt","1557041617549511719","4",NULL,&listing,&resp_headers);
    struct list_head *pos;
    if(listing){
       list_for_each(pos, listing->root){
         part_summary_t* temp = list_entry(pos,struct part_summary_t,node);
         printf("0000000 id %s\n", temp->eTag.data);
       } 
    }
}

void get_buf_object_test(request_options_t *options,oos_status_t *status){
    oos_string_t* content = (oos_string_t*)oos_pcalloc(options->pool, sizeof(*content));;
    oos_table_t* resp_headers = oos_table_make(options->pool, 1);
    int pos = 0;
    const oos_array_header_t *tarr;
    const oos_table_entry_t *telts;
    oos_table_t* medadata = NULL;
    oos_table_t* req_header = oos_table_make(options->pool, 1);
    //oos_table_set(req_header, "Range", "1-3");
    status = oos_get_object_to_buffer_ex(options,BUCKET_NAME,"your_object", req_header, content,
            &medadata,&resp_headers);
    if (medadata) {
        tarr = oos_table_elts(medadata);
        telts = (oos_table_entry_t*)tarr->elts;
        for (pos = 0; pos < tarr->nelts; ++pos) {
                printf("--%s: %s\n",telts[pos].key, telts[pos].val);
        }
    }
    if(resp_headers){
        tarr = oos_table_elts(resp_headers);
        telts = (oos_table_entry_t*)tarr->elts;
        for (pos = 0; pos < tarr->nelts; ++pos) {
                printf("--%s: %s\n",telts[pos].key, telts[pos].val);
        }
    }

    printf("service code %d\n", status->code);
    printf("service msg service %s\n", status->error_msg);
    printf("content %s\n", content->data);
}

void create_ctyun_get_uasge_test(request_options_t *options,oos_status_t *status){
    printf("0000000\n");
    int size =1;
    oos_string_t* a ;
    oos_string_t pools[1]={3,"abc"};
    // oos_str_set(options->pool,  a,"1233");
    // memcpy((char *)&pools[0],(char *)a,sizeof(*a));
    // oos_string_t* b;
    // oos_str_set(options->pool,  b, "abc");
    // memcpy((char *)&pools[1],(char *)b,sizeof(*b));

    status = oos_ctyun_create_get_uasge(options,"2018-11-30",pools,size, "True");
}

int main()
{
    oos_initialize();
    oos_pool_t *p = NULL;
    request_options_t *options = NULL;
    oos_status_t *status = NULL;
    oos_pool_create(&p, NULL);
    options = (request_options_t *)oos_pcalloc(p, sizeof(request_options_t));
    options->pool = p;
    oos_str_set(options->pool,  &options->access_key, ACCESS_KEY);
    oos_str_set(options->pool,  &options->secret_key, SECRET_KEY);
    oos_str_set(options->pool,  &options->endpoint, HOST_NAME);

    //======================== V2 or V4 ===================================
    options->is_v4 = OOS_TRUE;
    options->is_sign_payload = OOS_TRUE;

    // ========================  Access KEY ===============================
    // list_ctyun_access_key_test(options, status);
    // update_ctyun_access_key_test(options, status);
    // delete_ctyun_access_key_test(options, status);
    // create_access_key_test(options, status);

    // ========================  BUCKET ====================================
    //  get_regions_test(options, status);
    // create_bucket_test(options, status);
    // list_all_bucket_test();
     get_bucket_acl_test(options, status);
    // put_bucket_policy_test(options, status);
    // get_bucket_policy_test(options, status);
    // delete_bucket_policy_test(options, status);
    // put_bucket_website_test(options, status);
    // get_bucket_website_test(options, status);
    // delete_bucket_website_test(options, status);
    // put_bucket_logging_test(options, status);
    // get_bucket_location_test(options, status);
    // put_bucket_lifecycle_test(options, status);
    // get_bucket_lifecycle_test(options, status);
    // delete_bucket_lifecycle_test(options, status);
    // delete_bucket_cors_test(options, status);
    // put_bucket_cors_test(options, status);
    // get_bucket_cors_test(options, status);
    // get_bucket_accerlerate_test(options, status);
    // put_bucket_accelerate_test(options, status);
    // head_bucket_test(options, status);
    // get_bucket_location_test(options, status);

    // ========================  OBJECT ==================================
    // list_objects_test();
    // put_buf_object_test(options, status);
    // put_file_object_test(options, status);
    // get_buf_object_test(options, status);
    // get_file_object_test(options, status);
    // delete_object_test(options, status);
    // delete_multiple_object_test(options, status);
    // genrate_object_presignedurl_test(options, status);
    // head_object_test(options, status);
    // copy_object_test(options, status);

    //=========================  MutliPart ===============================
    // init_multipart_upload_test(options, status);
    // copy_part_test(options, status);
    // complete_multipart_upload_test(options, status);
    // list_multipart_uploads_test(options, status);
    // abort_multipart_upload_test(options, status);
    // upload_part_test(options, status);
    // list_parts_test(options, status);

    // ===============================================================================

    oos_pool_destroy(p);
    oos_terminate();
    return 0;
}



