
#ifndef _OOS_SDK_C_FILE_DEAL_H_
#define _OOS_SDK_C_FILE_DEAL_H_

#ifdef __cplusplus
extern "C" {
#endif

#include <stdio.h>
#include <string.h>
#include "curl/curl.h"
#include "buffer.h"

typedef struct {
	const char* data;
	int32_t offset;
	int32_t len;
} BufData;


extern void multipart_deal_down(void *handler, buffer* resp);
extern void multipart_deal(void *handler, void* ptr, size_t size, buffer* resp);
extern void meta_deal(void *handler, void* ptr, buffer* resp, size_t size);
extern void file_down(void *handler, FILE* file, buffer* resp);
extern void file_up(void *handler, FILE* file, curl_off_t size, buffer* resp);
extern void buf_up(void *handler, BufData* buf_data, curl_off_t size, buffer* resp);
extern void buf_down(void *handler, buffer* resp);
extern void buf_down_segment(void *handler, buffer* resp, void *callback);

#ifdef __cplusplus
}
#endif
#endif  //_OOS_SDK_C_FILE_DEAL_H_
