
#ifndef _OOS_SDK_C_MAKE_HEADER_H_
#define _OOS_SDK_C_MAKE_HEADER_H_

#ifdef __cplusplus
extern "C" {
#endif

#include "buffer.h"
#include "oos_api.h"

typedef enum {
    META_OP = 0,
    FILE_OP,
    BUF_OP,
    MULTI_OP,
    MULTI_COMPLETE_OP,
    PRE_SIGNED_URL,
    OpType_END
} OpType;
typedef enum {
    GET_METHOD = 0,
    PUT_METHOD,
    DELETE_METHOD,
    POST_METHOD,
    HEAD_METHOD,
    MethodType_END
} MethodType;


extern int make_header_presigned_url(const request_options_t* options, MethodType method_type,
    const char* bucket, const char* object, const char* data, int buf_len, const int expirs_sec,
    const char* query_args, const char* headers_str, buffer* resp, char** pre_signed_url);
    
extern void make_header(const request_options_t* options, MethodType method_type, 
    const char* bucket,const char* object,const char* file_path, 
    const char* query_args, const char* headers,buffer* resp, int* err);
    
extern void make_header_file(const request_options_t* options, MethodType method_type, 
    const char* bucket, const char* object, const char* file_path, const char* query_args,
    const char* headers, buffer* resp, int* err);
    
extern void make_header_buf(const request_options_t* options, MethodType method_type, 
    const char* bucket,const char* object, const char* buf, int buf_len, 
    const char* query_args, const char* headers, buffer* resp, int* err);

extern void make_header_post(const request_options_t* options, MethodType method_type, 
    const char* bucket,const char* object, const char* body, const char* query_args,
    const char* headers, buffer* resp, int* err);
    
extern void make_multiparts(const request_options_t* options, MethodType method_type,
    const char* bucket, const char* object, const char* buf_data, int buf_len, 
    const char* query_args, const char* headers, OpType op_type,
    buffer* resp, int* err);
    
extern void make_lifecycle(const request_options_t* options, MethodType method_type,
     const char* bucket, const char* object, const char* buf_data, int buf_len,
     const char* query_args, const char* headers, 
     buffer* resp, int* err);
    
#ifdef __cplusplus
}
#endif
#endif  // _KS3_SDK_C_MAKE_HEADER_H_
