#ifndef _OOS_SDK_C_STATUS_H_
#define _OOS_SDK_C_STATUS_H_

#include "oos_define.h"
#include "list.h"

#define STATUS_INVALID_PARAMETER    -100

typedef struct {
    int code; // > 0: http code, <0: client code
    char *error_msg;
}oos_status_t;

static APR_INLINE int oos_status_is_ok(oos_status_t *s)
{
    return s->code >= 0 && s->code < 300;
}

static APR_INLINE int oos_http_is_ok(int st)
{
    return st / 100 == 2;
}

static oos_status_t *oos_status_create(oos_pool_t *p)
{
    return (oos_status_t *)oos_pcalloc(p, sizeof(oos_status_t));
}

#define oos_status_set(s, c, ec, es)                                    \
    (s)->code = c; (s)->error_code = (char *)ec; (s)->error_msg = (char *)es


#endif
