
#ifndef _OOS_SDK_C_SIGN_H_
#define _OOS_SDK_C_SIGN_H_

#ifdef __cplusplus
extern "C" {
#endif

#include <stdio.h>
#include "rb_tree.h"
#include <stdbool.h>


bool isContained(const char *str, char c);
char *mystrtok_r(char* string_org,const char* demial, char **save_ptr);


extern char* make_string_to_sign_V4(const char* utc_time, const char* gmt_time,  const char* canon_request,
                                    const char* region, const char* service, char* string_to_sign);
extern char* make_canonicalized_request_V4(int method_type, const char* bucket, const char* object,
                                          const char* query_args,const char* headers, char* canon_request, char* signed_headers);
extern char* make_canonicalized_request_V4_presigned_url(int method_type, const char* bucket, const char* object,
                                          const char* query_args,const char* headers, char* canon_request, char* signed_headers);

extern void make_canon_query_param_V4( const char* query_args, char* res);
extern void make_canon_query_param_V4_presigned_url( const char* query_args, char* res);

extern char* make_resource_quote(const char* query_args, char* out_str);
extern char* make_origin_sign(int method_type, const char* bucket, 
    const char* obj, const char* query_args, const char* headers, 
    const char* time, char* origin_sign);
extern char* get_time(char* out_time);
extern char* get_date(char* out_time);
extern char* get_utc_time(char* out_time);
extern char* get_utc_time_expires(char* out_time, const int expire_sec);
extern void get_region(const char* body, const char* host, char* region);
extern void get_service(const char* body, char* service);

#ifdef __cplusplus
}
#endif
#endif  
