﻿#include "oos_api.h"
#include <mxml.h>
#include "response.h"
#include "xml_util.h"
void oos_delete_result_parse_from_body(oos_pool_t *p, const char* body, delete_multiple_list_t* list){
    mxml_node_t *tree;
    tree = mxmlLoadString(NULL, body, MXML_OPAQUE_CALLBACK);
    mxml_node_t *node;
    char *node_content=NULL;

    mxml_node_t *delete_result_node, *white_list_node;

    // deleted result
    delete_result_node = mxmlFindElement(tree, tree,"DeleteResult",NULL, NULL,MXML_DESCEND);
    if(delete_result_node && delete_result_node->child){
        // deleted list
        mxml_node_t *deleted_node;
        for (deleted_node = mxmlFindElement(delete_result_node, delete_result_node,"Deleted",NULL, NULL,
                                       MXML_DESCEND);deleted_node != NULL;deleted_node = mxmlFindElement(deleted_node, delete_result_node,
                                                                                               "Deleted",NULL, NULL,MXML_DESCEND)){
            if(NULL != deleted_node && NULL != deleted_node->child){
                // KEY
                mxml_node_t *key_node = mxmlFindElement(deleted_node,deleted_node,"Key",NULL,NULL,MXML_DESCEND);
                if(NULL != key_node && NULL != key_node->child){
                    node_content = key_node->child->value.opaque;
                    if(node_content){
                        list_delete_node_t* tmp;
                        list_for_each_entry(tmp, &list->delete_list.node, node)
                        {
                            if(0 == strcmp(tmp->object_key.data, node_content)){
                                oos_str_set(p, &tmp->result, "sucess");
                                break;
                            }
                        }
                    }
                }
            }
        }
    }

    // Error result
    delete_result_node = mxmlFindElement(tree, tree,"DeleteResult",NULL, NULL,MXML_DESCEND);
    if(delete_result_node && delete_result_node->child){
        // error list
        mxml_node_t *error_node;
        for (error_node = mxmlFindElement(delete_result_node, delete_result_node,"Error",NULL, NULL,
                                       MXML_DESCEND);error_node != NULL;error_node = mxmlFindElement(error_node, delete_result_node,
                                                                                               "Error",NULL, NULL,MXML_DESCEND)){
            if(NULL != error_node && NULL != error_node->child){
                // KEY
                char* key_content = NULL;
                mxml_node_t *key_node = mxmlFindElement(error_node,error_node,"Key",NULL,NULL,MXML_DESCEND);
                if(NULL != key_node && NULL != key_node->child){
                    key_content = key_node->child->value.opaque;
                }

                // Message
                char* message_content = NULL;
                mxml_node_t *message_node = mxmlFindElement(error_node,error_node,"Message",NULL,NULL,MXML_DESCEND);
                if(NULL != message_node && NULL != message_node->child){
                    message_content = message_node->child->value.opaque;
                }

                if(key_content && message_content){
                    list_delete_node_t* tmp;
                    list_for_each_entry(tmp, &list->delete_list.node, node)
                    {
                        if(0 == strcmp(tmp->object_key.data, key_content)){
                            oos_str_set(p, &tmp->result, message_content);
                            break;
                        }
                    }
                }
            }
        }
    }
    mxmlDelete(tree);
    return ;
}
oos_list_object_t* oos_list_objects_parse_from_body(oos_pool_t *p, const char* body){
	mxml_node_t *tree;
	tree = mxmlLoadString(NULL, body, MXML_OPAQUE_CALLBACK);
	mxml_node_t *node;
    oos_list_object_t* objects;
	objects = oos_pcalloc(p, sizeof(*objects));
	objects->root = oos_pcalloc(p, sizeof(*objects->root));
    objects->prefix_root = oos_pcalloc(p, sizeof(*objects->prefix_root));
    

	INIT_LIST_HEAD(objects->root);
    INIT_LIST_HEAD(objects->prefix_root);
	oos_list_object_content_t* contents;
    oos_list_object_common_prefix_t* prefix;
	char *node_content=NULL;

	node = mxmlFindElement(tree, tree,"Name",NULL, NULL,MXML_DESCEND);
	if(NULL != node && NULL != node->child){
		node_content = node->child->value.opaque;
        oos_str_set(p, &objects->name,node_content);
	}

	node = mxmlFindElement(tree,tree,"Prefix",NULL,NULL,MXML_DESCEND);
	if(NULL != node && NULL != node->child){
		node_content = node->child->value.opaque;
        oos_str_set(p, &objects->prefix,node_content);
	}

	node = mxmlFindElement(tree,tree,"Marker",NULL,NULL,MXML_DESCEND);
	if(NULL != node && NULL != node->child){
		node_content = node->child->value.opaque;
        oos_str_set(p, &objects->marker,node_content);
	}

	node = mxmlFindElement(tree, tree, "NextMarker", NULL, NULL, MXML_DESCEND);
	if (NULL != node && NULL != node->child) {
		node_content = node->child->value.opaque;
		oos_str_set(p, &objects->nextMarker, node_content);
	}
	

	node = mxmlFindElement(tree,tree,"MaxKeys",NULL,NULL,MXML_DESCEND);
	if(NULL != node && NULL != node->child){
		node_content = node->child->value.opaque;
        oos_str_set(p, &objects->maxKeys,node_content);
	}

    node = mxmlFindElement(tree,tree,"Delimiter",NULL,NULL,MXML_DESCEND);
    if(NULL != node && NULL != node->child){
        node_content = node->child->value.opaque;
        oos_str_set(p, &objects->delimiter,node_content);
    }

	node = mxmlFindElement(tree,tree,"IsTruncated",NULL,NULL,MXML_DESCEND);
	if(NULL != node && NULL != node->child){
		node_content = node->child->value.opaque;
        oos_str_set(p, &objects->isTruncated,node_content);
	}

	for (node = mxmlFindElement(tree, tree,"Contents",NULL, NULL,
                MXML_DESCEND);node != NULL;node = mxmlFindElement(node, tree,
                "Contents",NULL, NULL,MXML_DESCEND)){
		mxml_node_t *entity;
    	contents = oos_pcalloc(p, sizeof(*contents)); //?
        if (NULL == node || node->child == NULL) {
        	continue;
        }

    	entity = mxmlFindElement(node, tree,"Key",NULL, NULL,MXML_DESCEND);
    	if(NULL != entity && NULL != entity->child){
        	node_content = entity->child->value.opaque;
            oos_str_set(p, &contents->key,node_content);
    	}

		entity = mxmlFindElement(node, tree,"LastModified",NULL, NULL,MXML_DESCEND);
    	if(NULL != entity && NULL != entity->child){
        	node_content = entity->child->value.opaque;
            oos_str_set(p, &contents->lastModified,node_content);
    	}

    	entity = mxmlFindElement(node, tree,"ETag",NULL, NULL,MXML_DESCEND);
    	if(NULL != entity && NULL != entity->child){
        	node_content = entity->child->value.opaque;
            oos_str_set(p, &contents->eTag,node_content);
    	}

    	entity = mxmlFindElement(node, tree,"Size",NULL, NULL,MXML_DESCEND);
    	if(NULL != entity && NULL != entity->child){
        	node_content = entity->child->value.opaque;
            oos_str_set(p, &contents->size,node_content);
    	}

    	entity = mxmlFindElement(node, tree,"StorageClass",NULL, NULL,MXML_DESCEND);
    	if(NULL != entity && NULL != entity->child){
        	node_content = entity->child->value.opaque;
            oos_str_set(p, &contents->storageClass,node_content);
    	}

    	entity = mxmlFindElement(node, tree,"Owner",NULL, NULL,MXML_DESCEND);
    	if(NULL != entity && NULL != entity->child){
    		mxml_node_t *owner;
    		owner = mxmlFindElement(entity, tree,"ID",NULL, NULL,MXML_DESCEND);
			if(NULL != owner && NULL != owner->child){
	        	node_content = owner->child->value.opaque;
                oos_str_set(p, &contents->owner_id,node_content);
	    	}

	    	owner = mxmlFindElement(entity, tree,"DisplayName",NULL, NULL,MXML_DESCEND);
			if(NULL != owner && NULL != owner->child){
	        	node_content = owner->child->value.opaque;
                oos_str_set(p, &contents->owner_DisplayName,node_content);
	    	}
    	}
    	
        INIT_LIST_HEAD(&contents->node);
        list_add_tail(&contents->node, objects->root);
     }

    for(node = mxmlFindElement(tree, tree,"CommonPrefixes",NULL, NULL,
            MXML_DESCEND);node != NULL;node = mxmlFindElement(node, tree,
            "CommonPrefixes",NULL, NULL,MXML_DESCEND)){
        mxml_node_t *entity;
        prefix = oos_pcalloc(p,sizeof(*prefix));

        if (NULL == node || node->child == NULL) {
            continue;
        }
        entity = mxmlFindElement(node, tree,"Prefix",NULL, NULL,MXML_DESCEND);
        if(NULL != entity && NULL != entity->child){
            node_content = entity->child->value.opaque;
            oos_str_set(p, &prefix->prefix,node_content);
        }
        INIT_LIST_HEAD(&prefix->node);
        list_add_tail(&prefix->node, objects->prefix_root);
    }

    // struct list_head *pos; 

    // list_for_each(pos, objects->prefix_root){
    // 	oos_list_object_common_prefix_t* temp = list_entry(pos,struct oos_list_object_common_prefix_t,node);
    // 	printf("0000000 id %s\n", temp->prefix.data);
    // }

     mxmlDelete(tree);
    return objects;
}

oos_list_bucket_t* oos_list_bucket_parse_from_body(oos_pool_t *p,const char* body){
	mxml_node_t *tree;
	tree = mxmlLoadString(NULL, body, MXML_OPAQUE_CALLBACK);
	mxml_node_t *node;
    oos_list_bucket_t* buckets;
	buckets = oos_pcalloc(p, sizeof(*buckets)); 
	buckets->root = oos_pcalloc(p, sizeof(*buckets->root));
	INIT_LIST_HEAD(buckets->root);
	oos_list_bucket_content_t* contents;
	char *node_content=NULL;

	node = mxmlFindElement(tree, tree,"Owner",NULL, NULL,MXML_DESCEND);
	if(NULL != node && NULL != node->child){
		mxml_node_t *owner;
		owner = mxmlFindElement(node, tree,"ID",NULL, NULL,MXML_DESCEND);
		if(NULL != owner && NULL != owner->child){
        	node_content = owner->child->value.opaque;
            oos_str_set(p, &buckets->owner_id,node_content);
    	}
    	owner = mxmlFindElement(node, tree,"DisplayName",NULL, NULL,MXML_DESCEND);
		if(NULL != owner && NULL != owner->child){
        	node_content = owner->child->value.opaque;
            oos_str_set(p, &buckets->owner_DisplayName,node_content);
    	}
	}

	node = mxmlFindElement(tree, tree,"Buckets",NULL, NULL,MXML_DESCEND);
	if(NULL == node || node->child == NULL){
		return buckets;
	}

	for (node = mxmlFindElement(node, tree,"Bucket",NULL, NULL,
                MXML_DESCEND);node != NULL;node = mxmlFindElement(node, tree,
                "Bucket",NULL, NULL,MXML_DESCEND)){
		if (NULL == node || node->child == NULL) {
        	continue;
        }
		mxml_node_t *entity;
		contents = oos_pcalloc(p, sizeof(*contents));

		entity = mxmlFindElement(node, tree,"Name",NULL, NULL,MXML_DESCEND);
    	if(NULL != entity && NULL != entity->child){
        	node_content = entity->child->value.opaque;
            oos_str_set(p, &contents->name,node_content);
    	}
    	entity = mxmlFindElement(node, tree,"CreationDate",NULL, NULL,MXML_DESCEND);
    	if(NULL != entity && NULL != entity->child){
        	node_content = entity->child->value.opaque;
            oos_str_set(p, &contents->creationDate,node_content);
    	}
    	INIT_LIST_HEAD(&contents->node);
        list_add_tail(&contents->node, buckets->root);
	}

	// struct list_head *pos; 
 //    list_for_each(pos, buckets->root){
 //    	oos_list_bucket_content_t* temp = list_entry(pos,struct oos_list_bucket_content_t,node);
 //    	printf("0000000 id %s\n", temp->name.data);
 //    }
    mxmlDelete(tree);
	return buckets;
}

oos_list_access_key_t* oos_list_access_parse_from_body(oos_pool_t *p,const char* body){
    mxml_node_t *tree;
    tree = mxmlLoadString(NULL, body, MXML_OPAQUE_CALLBACK);
    mxml_node_t *node;
    oos_list_access_key_t* keys;
    keys = oos_pcalloc(p,sizeof(*keys)); 
    keys->root = oos_pcalloc(p,sizeof(*keys->root));
    INIT_LIST_HEAD(keys->root);
    oos_list_access_key_member_t* member;
    char *node_content=NULL;

    node = mxmlFindElement(tree, tree,"ListAccessKeysResult",NULL, NULL,MXML_DESCEND);
    if(NULL == node || node->child == NULL)
        return keys;
    mxml_node_t *entity;
    entity = mxmlFindElement(node, tree,"UserName",NULL, NULL,MXML_DESCEND);
    if(NULL != entity && NULL != entity->child){
        node_content = entity->child->value.opaque;
        oos_str_set(p, &keys->userName,node_content);
    }
    entity = mxmlFindElement(node, tree,"IsTruncated",NULL, NULL,MXML_DESCEND);
    if(NULL != entity && NULL != entity->child){
        node_content = entity->child->value.opaque;
        oos_str_set(p, &keys->isTruncated,node_content);
    }
    entity = mxmlFindElement(node, tree,"Marker",NULL, NULL,MXML_DESCEND);
    if(NULL != entity && NULL != entity->child){
        node_content = entity->child->value.opaque;
        oos_str_set(p, &keys->marker,node_content);
    }

    for (node = mxmlFindElement(node, tree,"member",NULL, NULL,
                MXML_DESCEND);node != NULL;node = mxmlFindElement(node, tree,
                "member",NULL, NULL,MXML_DESCEND)){
        member = malloc(sizeof(*member));
        entity = mxmlFindElement(node, tree,"UserName",NULL, NULL,MXML_DESCEND);
        if(NULL != entity && NULL != entity->child){
            node_content = entity->child->value.opaque;
            oos_str_set(p, &member->userName,node_content);
        }
        entity = mxmlFindElement(node, tree,"AccessKeyId",NULL, NULL,MXML_DESCEND);
        if(NULL != entity && NULL != entity->child){
            node_content = entity->child->value.opaque;
            oos_str_set(p, &member->accessKeyId,node_content);
        }
        entity = mxmlFindElement(node, tree,"Status",NULL, NULL,MXML_DESCEND);
        if(NULL != entity && NULL != entity->child){
            node_content = entity->child->value.opaque;
            oos_str_set(p, &member->status,node_content);
        }
        entity = mxmlFindElement(node, tree,"IsPrimary",NULL, NULL,MXML_DESCEND);
        if(NULL != entity && NULL != entity->child){
            node_content = entity->child->value.opaque;
            oos_str_set(p, &member->isPrimary,node_content);
        }

        INIT_LIST_HEAD(&member->node);
        list_add_tail(&member->node, keys->root);
    }
    mxmlDelete(tree);
    return keys;
}

/**
    done .to be continue
*/
trigger_configuration_t* oos_get_bucket_trigger_parse_from_body(oos_pool_t *p, const char* body){
    mxml_node_t *tree;
    tree = mxmlLoadString(NULL, body, MXML_OPAQUE_CALLBACK);
    mxml_node_t *node;
    char *node_content=NULL;
    trigger_configuration_t* config;
    config = oos_pcalloc(p, sizeof(*config)); 
    // &config->node = oos_pcalloc(p,sizeof(*config->node));
    INIT_LIST_HEAD(&config->node);

    trigger_configuration_t* trigger;
    mxml_node_t *entity;

    for (node = mxmlFindElement(tree, tree,"Trigger",NULL, NULL,
                MXML_DESCEND);node != NULL;node = mxmlFindElement(node, tree,
                "Trigger",NULL, NULL,MXML_DESCEND)){
        trigger = oos_pcalloc(p, sizeof(*trigger)); 
        entity = mxmlFindElement(node, tree,"TriggerName",NULL, NULL,MXML_DESCEND);
        if(NULL != entity && NULL != entity->child){
            node_content = entity->child->value.opaque;
            oos_str_set(p, &trigger->triggerName,node_content);
            printf("node_content  %s\n", node_content);
        }
        entity = mxmlFindElement(node, tree,"IsDefault",NULL, NULL,MXML_DESCEND);
        if(NULL != entity && NULL != entity->child){
            node_content = entity->child->value.opaque;
            oos_str_set(p, &trigger->isDefault,node_content);
        }
        entity = mxmlFindElement(node, tree,"RemontEndPoint",NULL, NULL,MXML_DESCEND);
        if(NULL != entity && NULL != entity->child){
            node_content = entity->child->value.opaque;
            oos_str_set(p, &trigger->remontEndPoint,node_content);
        }
        entity = mxmlFindElement(node, tree,"ReplicaMode",NULL, NULL,MXML_DESCEND);
        if(NULL != entity && NULL != entity->child){
            node_content = entity->child->value.opaque;
            oos_str_set(p, &trigger->replicaMode,node_content);
        } 
        entity = mxmlFindElement(node, tree,"RemoteBucketName",NULL, NULL,MXML_DESCEND);
        if(NULL != entity && NULL != entity->child){
            node_content = entity->child->value.opaque;
            oos_str_set(p, &trigger->remoteBucketName,node_content);
        }
        entity = mxmlFindElement(node, tree,"RemoteAK",NULL, NULL,MXML_DESCEND);
        if(NULL != entity && NULL != entity->child){
            node_content = node->child->value.opaque;
            oos_str_set(p, &trigger->remoteAK,node_content);
        }
        entity = mxmlFindElement(node, tree,"RemoteSK",NULL, NULL,MXML_DESCEND);
        if(NULL != entity && NULL != entity->child){
            node_content = entity->child->value.opaque;
            oos_str_set(p, & trigger->remoteSK,node_content);
        }

        INIT_LIST_HEAD(&trigger->node);
        list_add_tail(&trigger->node, &config->node);
    }
    mxmlDelete(tree);
    return config;
}


void oos_parse_err_resp(response* resp){
	mxml_node_t* root ; 
	root = mxmlNewElement(MXML_NO_PARENT, "Error");
	mxml_node_t *tree;
	tree = mxmlLoadString(root, resp->body, MXML_OPAQUE_CALLBACK);

	if(NULL == tree || NULL == tree->child){
		return ;//do nothing
    }
    char code[128];
    char message[1024];
    mxml_node_t *entity;
    char *node_content=NULL;

    entity = mxmlFindElement(tree, tree,"Code",NULL, NULL,MXML_DESCEND);
	if(NULL != entity && NULL != entity->child){
    	node_content = entity->child->value.opaque;
    	memset(code,0,128);
        memcpy(code,node_content,strlen(node_content));
    }

    entity = mxmlFindElement(tree, tree,"Message",NULL, NULL,MXML_DESCEND);
	if(NULL != entity && NULL != entity->child){
    	node_content = entity->child->value.opaque;
    	memset(message,0,1024);
        memcpy(message,node_content,strlen(node_content));	
    }
    entity = mxmlFindElement(tree, tree,"RequestId",NULL, NULL,MXML_DESCEND);
	if(NULL != entity && NULL != entity->child){
    	node_content = entity->child->value.opaque;    	
        memcpy(resp->request_id,node_content,strlen(node_content));	
    }
	entity = mxmlFindElement(tree, tree,"HostId",NULL, NULL,MXML_DESCEND);
	if(NULL != entity && NULL != entity->child){
    	node_content = entity->child->value.opaque;    	
        memcpy(resp->host_id,node_content,strlen(node_content));	
    }
    if(strcmp(message,"")!=0){
        sprintf(resp->error_msg,"%s : %s",code,message);    
    }else {
        sprintf(resp->error_msg,"%s ",code);    
    }
    mxmlDelete(tree);
    return ;
}

region_configuration_t* oos_get_region_parse_from_body(oos_pool_t *p,const char* body){

    printf("=============body%s", body);

    mxml_node_t *tree;
    tree = mxmlLoadString(NULL, body, MXML_OPAQUE_CALLBACK);
    region_configuration_t* config;
    config = (region_configuration_t*)oos_pcalloc(p, sizeof(*config));
    INIT_LIST_HEAD(&config->meta_location_list.node);
    INIT_LIST_HEAD(&config->data_location_list.node);
    char *node_content=NULL;
    mxml_node_t *bucket_node, *meta_list, *data_list;
    bucket_node = mxmlFindElement(tree, tree,"BucketRegions",NULL, NULL,MXML_DESCEND);
    if(bucket_node && bucket_node->child){
        // location list
        meta_list = mxmlFindElement(bucket_node, tree,"MetadataRegions",NULL, NULL,MXML_DESCEND);
        if(meta_list && meta_list->child){
            mxml_node_t *region_node;
            for (region_node = mxmlFindElement(meta_list, meta_list,"Region",NULL, NULL,
                            MXML_DESCEND);region_node != NULL;region_node = mxmlFindElement(region_node, meta_list,
                            "Region",NULL, NULL,MXML_DESCEND)){

               if(NULL != region_node && NULL != region_node->child){
                  node_content = region_node->child->value.opaque;
                  if(node_content){
                     add_list_string_node_pool(p, node_content, &config->meta_location_list.node);
                   }
                }
            }
        }

        // data list
        data_list = mxmlFindElement(bucket_node, tree,"DataRegions",NULL, NULL,MXML_DESCEND);
        if(data_list && data_list->child){
            mxml_node_t *region_node;
            for (region_node = mxmlFindElement(data_list, data_list,"Region",NULL, NULL,
                            MXML_DESCEND);region_node != NULL;region_node = mxmlFindElement(region_node, data_list,
                            "Region",NULL, NULL,MXML_DESCEND)){

               if(NULL != region_node && NULL != region_node->child){
                  node_content = region_node->child->value.opaque;
                  if(node_content){
                     add_list_string_node_pool(p, node_content, &config->data_location_list.node);
                   }
                }
            }
        }
    }
    mxmlDelete(tree);
    return config;
}

cors_configuration_t* oos_get_cors_parse_from_body(oos_pool_t *p,const char* body){

    printf("=============body%s", body);

    mxml_node_t *tree;
    tree = mxmlLoadString(NULL, body, MXML_OPAQUE_CALLBACK);
    cors_configuration_t* config;
    config = (cors_configuration_t*)oos_pcalloc(p, sizeof(*config));
    INIT_LIST_HEAD(&config->cors_rule_list.node);
    INIT_LIST_HEAD(&config->cors_rule_list.allowed_origin_list.node);
    INIT_LIST_HEAD(&config->cors_rule_list.allowed_method_list.node);
    INIT_LIST_HEAD(&config->cors_rule_list.allowed_header_list.node);
    INIT_LIST_HEAD(&config->cors_rule_list.expose_header_list.node);

    char *node_content=NULL;
    mxml_node_t *cors_node, *orign_node, *method_node, *header_node, *expose_node, *id_node,
            *maxage_second_node;

    // cors lists
    for (cors_node = mxmlFindElement(tree, tree,"CORSRule",NULL, NULL,
                    MXML_DESCEND);cors_node != NULL;cors_node = mxmlFindElement(cors_node, tree,
                    "CORSRule",NULL, NULL,MXML_DESCEND)){

        list_cors_rule_node_t* list_cors_new_node;
        list_cors_new_node = oos_pcalloc(p, sizeof(*list_cors_new_node));
        INIT_LIST_HEAD(&list_cors_new_node->node);
        INIT_LIST_HEAD(&list_cors_new_node->allowed_origin_list.node);
        INIT_LIST_HEAD(&list_cors_new_node->allowed_method_list.node);
        INIT_LIST_HEAD(&list_cors_new_node->allowed_header_list.node);
        INIT_LIST_HEAD(&list_cors_new_node->expose_header_list.node);

        // orign list
        for (orign_node = mxmlFindElement(cors_node, cors_node,"AllowedOrigin",NULL, NULL,
             MXML_DESCEND);orign_node != NULL;orign_node = mxmlFindElement(orign_node, cors_node,
             "AllowedOrigin",NULL, NULL,MXML_DESCEND)){
            if(NULL != orign_node && NULL != orign_node->child){
                node_content = orign_node->child->value.opaque;
                if(node_content){
                    add_list_string_node_pool(p, node_content, &list_cors_new_node->allowed_origin_list.node);
                }
            }
        }

        // method list
        for (method_node = mxmlFindElement(cors_node, cors_node,"AllowedMethod",NULL, NULL,
             MXML_DESCEND);method_node != NULL;method_node = mxmlFindElement(method_node, cors_node,
             "AllowedMethod",NULL, NULL,MXML_DESCEND)){
            if(NULL != method_node && NULL != method_node->child){
                node_content = method_node->child->value.opaque;
                if(node_content){
                    add_list_string_node_pool(p, node_content, &list_cors_new_node->allowed_method_list.node);
                }
            }
        }

        // headers lists
        for (header_node = mxmlFindElement(cors_node, cors_node,"AllowedHeader",NULL, NULL,
             MXML_DESCEND);header_node != NULL;header_node = mxmlFindElement(header_node, cors_node,
             "AllowedHeader",NULL, NULL,MXML_DESCEND)){
            if(NULL != header_node && NULL != header_node->child){
                node_content = header_node->child->value.opaque;
                if(node_content){
                    add_list_string_node_pool(p, node_content, &list_cors_new_node->allowed_header_list.node);
                }
            }
        }

        // expose_node list
        for (expose_node = mxmlFindElement(cors_node, cors_node,"ExposeHeader",NULL, NULL,
             MXML_DESCEND);expose_node != NULL;expose_node = mxmlFindElement(expose_node, cors_node,
             "ExposeHeader",NULL, NULL,MXML_DESCEND)){
            if(NULL != expose_node && NULL != expose_node->child){
                node_content = expose_node->child->value.opaque;
                if(node_content){
                    add_list_string_node_pool(p, node_content, &list_cors_new_node->expose_header_list.node);
                }
            }
        }
        // id
        id_node = mxmlFindElement(cors_node, cors_node,"ID",NULL, NULL,MXML_DESCEND);
        if(NULL != id_node && NULL != id_node->child){
            node_content = id_node->child->value.opaque;
            if(node_content){
                oos_str_set(p, &list_cors_new_node->id, node_content);
            }
        }
        // maxage_second_node
        maxage_second_node = mxmlFindElement(cors_node, cors_node,"MaxAgeSeconds",NULL, NULL,MXML_DESCEND);
        if(NULL != maxage_second_node && NULL != maxage_second_node->child){
            node_content = maxage_second_node->child->value.opaque;
            if(node_content){
                list_cors_new_node->maxage_seconds = atoi(node_content);
            }
        }
        list_add_tail(&list_cors_new_node->node, &config->cors_rule_list.node);
    }
    mxmlDelete(tree);
    return config;
}

accelerate_configuration_t* oos_get_bucket_accelerate_parse_from_body(oos_pool_t *p,const char* body){
    //printf("------------%s\n", body);
    mxml_node_t *tree;
    tree = mxmlLoadString(NULL, body, MXML_OPAQUE_CALLBACK);
    mxml_node_t *node;
    char *node_content=NULL;
    accelerate_configuration_t* config;

    config = oos_pcalloc(p, sizeof(*config));
    INIT_LIST_HEAD(&config->ip_white_list.node);

    mxml_node_t *status_node, *white_list_node;

    // status
    status_node = mxmlFindElement(tree, tree,"Status",NULL, NULL,MXML_DESCEND);
    if(status_node && status_node->child){
        node_content = status_node->child->value.opaque;
        if(node_content && strncmp(node_content, "Enabled", strlen("Local")) == 0){
            config->status = ENABLED;
        }else{
            config->status = SUSPENDED;
        }
    }

    // location list
    white_list_node = mxmlFindElement(tree, tree,"IPWhiteLists",NULL, NULL,MXML_DESCEND);
    if(white_list_node && white_list_node->child){
        mxml_node_t *ip_node;
        for (ip_node = mxmlFindElement(white_list_node, white_list_node,"IP",NULL, NULL,
                                       MXML_DESCEND);ip_node != NULL;ip_node = mxmlFindElement(ip_node, white_list_node,
                                                                                               "IP",NULL, NULL,MXML_DESCEND)){

            if(NULL != ip_node && NULL != ip_node->child){
                node_content = ip_node->child->value.opaque;
                if(node_content){
                    add_list_string_node_pool(p, node_content, &config->ip_white_list.node);
                }
            }
        }
    }
    mxmlDelete(tree);
    return config;
}

location_configuration_t* oos_get_bucket_location_parse_from_body(oos_pool_t *p,const char* body){
    printf("------------%s\n", body);
    mxml_node_t *tree;
    tree = mxmlLoadString(NULL, body, MXML_OPAQUE_CALLBACK);
    mxml_node_t *node;
    char *node_content=NULL;
    location_configuration_t* config;

    config = oos_pcalloc(p, sizeof(*config));
    INIT_LIST_HEAD(&config->data_location_list.node);

    // meta
    mxml_node_t *meta_node, *meta_location;
    meta_node = mxmlFindElement(tree, tree,"MetadataLocationConstraint",NULL, NULL,MXML_DESCEND);
    if(meta_node && meta_node->child){
        meta_location = mxmlFindElement(meta_node, tree,"Location",NULL, NULL,MXML_DESCEND);
        if(meta_location && meta_location->child){
            node_content = meta_location->child->value.opaque;
            oos_str_set(p, &config->medadata_location, node_content);
        }
    }

    // data
    mxml_node_t *data_node, *data_type, *data_Schedule_strategy, *data_location_list;
    data_node = mxmlFindElement(tree, tree,"DataLocationConstraint",NULL, NULL,MXML_DESCEND);
    if(data_node && data_node->child){
        // type
        data_type = mxmlFindElement(data_node, tree,"Type",NULL, NULL,MXML_DESCEND);
        if(data_type && data_type->child){
            node_content = data_type->child->value.opaque;
            if(node_content && strncmp(node_content, "Local", strlen("Local")) == 0){
                config->data_location_type = LOCAL;
            }else{
                config->data_location_type = SPECIFIED;
            }
        }

        // schedule strategy
        data_Schedule_strategy = mxmlFindElement(data_node, tree,"ScheduleStrategy",NULL, NULL,MXML_DESCEND);
        if(data_Schedule_strategy && data_Schedule_strategy->child){
            node_content = data_Schedule_strategy->child->value.opaque;
            if(node_content && strncmp(node_content, "Allowed", strlen("Allowed")) == 0){
                config->data_schedule_strategy = ALLOWED;
            }else{
                config->data_schedule_strategy = NOTALLOWED;
            }
        }

        // location list
        data_location_list = mxmlFindElement(data_node, tree,"LocationList",NULL, NULL,MXML_DESCEND);
        if(data_location_list && data_location_list->child){
            mxml_node_t *location_node;
            for (location_node = mxmlFindElement(data_location_list, data_location_list,"Location",NULL, NULL,
                            MXML_DESCEND);location_node != NULL;location_node = mxmlFindElement(location_node, data_location_list,
                            "Location",NULL, NULL,MXML_DESCEND)){

               if(NULL != location_node && NULL != location_node->child){
                  node_content = location_node->child->value.opaque;
                  if(node_content){
                     add_list_string_node_pool(p, node_content, &config->data_location_list.node);
                   }
                }
            }
        }
    }
    mxmlDelete(tree);
    return config;
}
void oos_get_bucket_etag_parse_from_body(oos_pool_t *p,oos_string_t* etag, const char* body){
    printf("------------%s\n", body);
    mxml_node_t *tree;
    tree = mxmlLoadString(NULL, body, MXML_OPAQUE_CALLBACK);
    mxml_node_t *node;
    char *node_content=NULL;

    // etag
    mxml_node_t *etag_node;
    etag_node = mxmlFindElement(tree, tree,"ETag",NULL, NULL,MXML_DESCEND);
    if(etag_node && etag_node->child){
        node_content = etag_node->child->value.opaque;
        if(node_content || strlen(node_content) > 0){
            etag->data = oos_pcalloc(p, strlen(node_content)+1);
            oos_str_set(p, etag, node_content);
        }
    }
    mxmlDelete(tree);
}

acl_configuration_t* oos_get_bucket_acl_parse_from_body(oos_pool_t *p,const char* body){
    printf("------------%s\n", body);
    mxml_node_t *tree;
    tree = mxmlLoadString(NULL, body, MXML_OPAQUE_CALLBACK);
    mxml_node_t *node;
    char *node_content=NULL;
    acl_configuration_t* config;

    config = oos_pcalloc(p, sizeof(*config));
    INIT_LIST_HEAD(&config->grant_list.node);

    // owner
    mxml_node_t *owner_node;
    owner_node = mxmlFindElement(tree, tree,"Owner",NULL, NULL,MXML_DESCEND);
    if(owner_node && owner_node->child){
        // ID
        mxml_node_t *tmp_node;
        tmp_node = mxmlFindElement(owner_node, tree,"ID",NULL, NULL,MXML_DESCEND);
        if(tmp_node && tmp_node->child){
            node_content = tmp_node->child->value.opaque;
            if(node_content){
                oos_str_set(p, &config->id, node_content);
            }
        }
        // DisplayName
        tmp_node = NULL;
        tmp_node = mxmlFindElement(owner_node, tree,"DisplayName",NULL, NULL,MXML_DESCEND);
        if(tmp_node && tmp_node->child){
            node_content = tmp_node->child->value.opaque;
            if(node_content){
                oos_str_set(p, &config->display_name, node_content);
            }
        }
    }

    // AccessControlList
    mxml_node_t *access_control_list_node;
    access_control_list_node = mxmlFindElement(tree, tree,"AccessControlList",NULL, NULL,MXML_DESCEND);
    if(access_control_list_node && access_control_list_node->child){
        // grant
        mxml_node_t *grant_node, *grantee_node, *uri_node, *permisiion_node;
        for (grant_node = mxmlFindElement(access_control_list_node, access_control_list_node,"Grant",NULL, NULL,
                        MXML_DESCEND);grant_node != NULL;grant_node = mxmlFindElement(grant_node, access_control_list_node,
                        "Grant",NULL, NULL,MXML_DESCEND)){

           if(grant_node && grant_node->child){
               // Init a grant info
               acl_grant_info * new_grant;
               new_grant = oos_pcalloc(p, sizeof(*new_grant));
               INIT_LIST_HEAD(&new_grant->node);
               // grantee
               grantee_node = mxmlFindElement(grant_node, grant_node,"Grantee",NULL, NULL,MXML_DESCEND);
               // URI
               if(grantee_node && grantee_node->child){
                   uri_node = mxmlFindElement(grantee_node, grantee_node,"URI",NULL, NULL,MXML_DESCEND);
                   if(uri_node && uri_node->child){
                       node_content = uri_node->child->value.opaque;
                       if(node_content){
                           oos_str_set(p, &new_grant->grantee_uri, node_content);
                       }
                   }
               }
               // permission
               permisiion_node = mxmlFindElement(grant_node, grant_node,"Permission",NULL, NULL,MXML_DESCEND);
               if(permisiion_node && permisiion_node->child){
                   node_content = permisiion_node->child->value.opaque;
                   if(node_content){
                       oos_str_set(p, &new_grant->permission, node_content);
                   }
               }
               // add grant list
              list_add_tail(&new_grant->node, &config->grant_list.node);
           }
        }
    }
    mxmlDelete(tree);
    return config;
}


lifecycle_configuration_t* oos_get_bucket_lifecycle_parse_from_body(oos_pool_t *p,const char* body){
    mxml_node_t *tree;
    tree = mxmlLoadString(NULL, body, MXML_OPAQUE_CALLBACK);
    mxml_node_t *node;
    char *node_content=NULL;
    lifecycle_configuration_t* config;
    config = oos_pcalloc(p, sizeof(*config)); 
    INIT_LIST_HEAD(&config->node);
    mxml_node_t *entity;
    lifecycle_configuration_t* rule;
    for (node = mxmlFindElement(tree, tree,"Rule",NULL, NULL,
                MXML_DESCEND);node != NULL;node = mxmlFindElement(node, tree,
                "Rule",NULL, NULL,MXML_DESCEND)){
        rule = oos_pcalloc(p, sizeof(*rule));
        rule->days = -1; 
        entity = mxmlFindElement(node, tree,"ID",NULL, NULL,MXML_DESCEND);
        if(NULL != entity && NULL != entity->child){
            node_content = entity->child->value.opaque;
            oos_str_set(p, &rule->ruleid,node_content);
        }
        entity = mxmlFindElement(node, tree,"Prefix",NULL, NULL,MXML_DESCEND);
        if(NULL != entity && NULL != entity->child){
            node_content = entity->child->value.opaque;
            oos_str_set(p, &rule->prefix,node_content);
        }
        entity = mxmlFindElement(node, tree,"Status",NULL, NULL,MXML_DESCEND);
        if(NULL != entity && NULL != entity->child){
            node_content = entity->child->value.opaque;
            oos_str_set(p, &rule->status,node_content);
        }
        entity = mxmlFindElement(node, node,"Days",NULL, NULL,MXML_DESCEND);
        if(NULL != entity && NULL != entity->child){
            node_content = entity->child->value.opaque;
            rule->days = atoi(node_content);
        }
        entity = mxmlFindElement(node, node,"Date",NULL, NULL,MXML_DESCEND);
        if(NULL != entity && NULL != entity->child){
            node_content = entity->child->value.opaque;
            oos_str_set(p, &rule->date,node_content);
        }
        INIT_LIST_HEAD(&rule->node);
        list_add_tail(&rule->node, &config->node);
    }
    mxmlDelete(tree);
    return config;
}

website_configuration_t* oos_get_bucket_website_parse_from_body(oos_pool_t *p,const char* body){
    mxml_node_t *tree;
    tree = mxmlLoadString(NULL, body, MXML_OPAQUE_CALLBACK);
    mxml_node_t *node;
    char *node_content=NULL;
    website_configuration_t* config;
    config = oos_pcalloc(p, sizeof(*config)); 

    node = mxmlFindElement(tree, tree,"Suffix",NULL, NULL,MXML_DESCEND);
    if(NULL != node && NULL != node->child){
        node_content = node->child->value.opaque;
        oos_str_set(p, &config->suffix,node_content);
    }

    node = mxmlFindElement(tree, tree,"Key",NULL, NULL,MXML_DESCEND);
    if(NULL != node && NULL != node->child){
        node_content = node->child->value.opaque;
        oos_str_set(p, &config->key,node_content);
    }
    mxmlDelete(tree);
    return config;
}

logging_configuration_t* oos_get_bucket_logging_parse_from_body(oos_pool_t *p, const char* body ){
    mxml_node_t *tree;
    tree = mxmlLoadString(NULL, body, MXML_OPAQUE_CALLBACK);
    mxml_node_t *node;
    char *node_content=NULL;
    logging_configuration_t* config;
    config = oos_pcalloc(p, sizeof(*config)); 

    node = mxmlFindElement(tree, tree,"TargetBucket",NULL, NULL,MXML_DESCEND);
    if(NULL != node && NULL != node->child){
        node_content = node->child->value.opaque;
        oos_str_set(p, &config->targetBucket,node_content);
    }
    node = mxmlFindElement(tree, tree,"TargetPrefix",NULL, NULL,MXML_DESCEND);
    if(NULL != node && NULL != node->child){
        node_content = node->child->value.opaque;
        oos_str_set(p, &config->targetPrefix,node_content);
    }
    node = mxmlFindElement(tree, tree,"TriggerTargetBucket",NULL, NULL,MXML_DESCEND);
    if(NULL != node && NULL != node->child){
        node_content = node->child->value.opaque;
        oos_str_set(p, &config->triggerTargetBucket,node_content);
    }
    node = mxmlFindElement(tree, tree,"TriggerTargetPrefix",NULL, NULL,MXML_DESCEND);
    if(NULL != node && NULL != node->child){
        node_content = node->child->value.opaque;
        oos_str_set(p, &config->triggerTargetPrefix,node_content);
    }
    node = mxmlFindElement(tree, tree,"TriggerSourceBucket",NULL, NULL,MXML_DESCEND);
    if(NULL != node && NULL != node->child){
        node_content = node->child->value.opaque;
        oos_str_set(p, &config->triggerSourceBucket,node_content);
    }
    node = mxmlFindElement(tree, tree,"TriggerSourcePrefix",NULL, NULL,MXML_DESCEND);
    if(NULL != node && NULL != node->child){
        node_content = node->child->value.opaque;
        oos_str_set(p, &config->triggerSourcePrefix,node_content);
    }
    mxmlDelete(tree);
    return config;

}

oos_list_access_key_member_t* oos_create_access_key_parse_from_body(oos_pool_t *p,const char* body){
    mxml_node_t *tree;
    tree = mxmlLoadString(NULL, body, MXML_OPAQUE_CALLBACK);
    mxml_node_t *node;
    char *node_content=NULL;
    oos_list_access_key_member_t* key;
    key = oos_pcalloc(p, sizeof(*key));

    node = mxmlFindElement(tree, tree,"UserName",NULL, NULL,MXML_DESCEND);
    if(NULL != node && NULL != node->child){
        node_content = node->child->value.opaque;
        oos_str_set(p, &key->userName,node_content);
    }
    node = mxmlFindElement(tree, tree,"AccessKeyId",NULL, NULL,MXML_DESCEND);
    if(NULL != node && NULL != node->child){
        node_content = node->child->value.opaque;
        oos_str_set(p, &key->accessKeyId,node_content);
        printf("accessKeyId %s\n", key->accessKeyId.data);
    }
    node = mxmlFindElement(tree, tree,"Status",NULL, NULL,MXML_DESCEND);
    if(NULL != node && NULL != node->child){
        node_content = node->child->value.opaque;
        oos_str_set(p, &key->status,node_content);
    }
    node = mxmlFindElement(tree, tree,"IsPrimary",NULL, NULL,MXML_DESCEND);
    if(NULL != node && NULL != node->child){
        node_content = node->child->value.opaque;
        oos_str_set(p, &key->isPrimary,node_content);
    }
    node = mxmlFindElement(tree, tree,"SecretAccessKey",NULL, NULL,MXML_DESCEND);
    if(NULL != node && NULL != node->child){
        node_content = node->child->value.opaque;
        oos_str_set(p, &key->secretAccessKey,node_content);
        printf("SecretAccessKey %s\n", key->secretAccessKey.data);
    }
    mxmlDelete(tree);
    return key;
}

initiate_multipart_upload_result_t* oos_multipart_uploadId_parse_from_body(oos_pool_t *p,const char* body){
    mxml_node_t *tree;
    tree = mxmlLoadString(NULL, body, MXML_OPAQUE_CALLBACK);
    mxml_node_t *node;
    char *node_content=NULL;
    initiate_multipart_upload_result_t* result;
    result = oos_pcalloc(p, sizeof(*result));

    node = mxmlFindElement(tree, tree,"Bucket",NULL, NULL,MXML_DESCEND);
    if(NULL != node && NULL != node->child){
        node_content = node->child->value.opaque;
        oos_str_set(p, &result->bucket,node_content);
    }
    node = mxmlFindElement(tree, tree,"Key",NULL, NULL,MXML_DESCEND);
    if(NULL != node && NULL != node->child){
        node_content = node->child->value.opaque;
        oos_str_set(p, &result->key,node_content);
    }
    node = mxmlFindElement(tree, tree,"UploadId",NULL, NULL,MXML_DESCEND);
    if(NULL != node && NULL != node->child){
        node_content = node->child->value.opaque;
        oos_str_set(p, &result->uploadId,node_content);
    }
    mxmlDelete(tree);
    return result;
}   

oos_list_multipart_uploads_t* oos_list_multipart_upload_parse_from_body(oos_pool_t *p,const char* body){
    mxml_node_t *tree;
    tree = mxmlLoadString(NULL, body, MXML_OPAQUE_CALLBACK);
    mxml_node_t *node;
    oos_list_multipart_uploads_t* list_upload;
    list_upload = oos_pcalloc(p,sizeof(*list_upload)); 

    node = mxmlFindElement(tree, tree,"ListMultipartUploadsResult",NULL, NULL,MXML_DESCEND);
    if(NULL == node || node->child == NULL){
        mxmlDelete(tree);
        return NULL;
    }

    list_upload->root = oos_pcalloc(p, sizeof(*list_upload->root));
    INIT_LIST_HEAD(list_upload->root);

	list_upload->prefix_root = oos_pcalloc(p, sizeof(*list_upload->prefix_root));
	INIT_LIST_HEAD(list_upload->prefix_root);
	
    oos_list_multipart_uploads_content_t* content;
	oos_list_multipart_uploads_common_prefix_t* prefix;

    char *node_content=NULL;

    mxml_node_t *entity;
    entity = mxmlFindElement(node, tree,"Bucket",NULL, NULL,MXML_DESCEND);
    if(NULL != entity && NULL != entity->child){
        node_content = entity->child->value.opaque;
        oos_str_set(p, &list_upload->bucket,node_content);
    }
    entity = mxmlFindElement(node, tree,"KeyMarker",NULL, NULL,MXML_DESCEND);
    if(NULL != entity && NULL != entity->child){
        node_content = entity->child->value.opaque;
        oos_str_set(p, &list_upload->keyMarker,node_content);
    }
	entity = mxmlFindElement(node, tree, "NextKeyMarker", NULL, NULL, MXML_DESCEND);
	if (NULL != entity && NULL != entity->child) {
		node_content = entity->child->value.opaque;
		oos_str_set(p, &list_upload->nextKeyMarker, node_content);
	}
    entity = mxmlFindElement(node, tree,"UploadIdMarker",NULL, NULL,MXML_DESCEND);
    if(NULL != entity && NULL != entity->child){
        node_content = entity->child->value.opaque;
        oos_str_set(p, &list_upload->uploadIdMarker,node_content);
    }
	entity = mxmlFindElement(node, tree, "NextUploadIdMarker", NULL, NULL, MXML_DESCEND);
	if (NULL != entity && NULL != entity->child) {
		node_content = entity->child->value.opaque;
		oos_str_set(p, &list_upload->nextUploadIdMarker, node_content);
	}
    entity = mxmlFindElement(node, tree,"MaxUploads",NULL, NULL,MXML_DESCEND);
    if(NULL != entity && NULL != entity->child){
        node_content = entity->child->value.opaque;
        oos_str_set(p, &list_upload->maxUploads,node_content);
    }
    entity = mxmlFindElement(node, tree,"IsTruncated",NULL, NULL,MXML_DESCEND);
    if(NULL != entity && NULL != entity->child){
        node_content = entity->child->value.opaque;
        oos_str_set(p, &list_upload->isTruncated,node_content);
    }

     for (node = mxmlFindElement(node, tree,"Upload",NULL, NULL,
                MXML_DESCEND);node != NULL;node = mxmlFindElement(node, tree,
                "Upload",NULL, NULL,MXML_DESCEND)){
        content = oos_pcalloc(p, sizeof(*content));
        entity = mxmlFindElement(node, tree,"Key",NULL, NULL,MXML_DESCEND);
        if(NULL != entity && NULL != entity->child){
            node_content = entity->child->value.opaque;
            oos_str_set(p, &content->key,node_content);
        }
        entity = mxmlFindElement(node, tree,"UploadId",NULL, NULL,MXML_DESCEND);
        if(NULL != entity && NULL != entity->child){
            node_content = entity->child->value.opaque;
            oos_str_set(p, &content->uploadId,node_content);
        }
        entity = mxmlFindElement(node, tree,"StorageClass",NULL, NULL,MXML_DESCEND);
        if(NULL != entity && NULL != entity->child){
            node_content = entity->child->value.opaque;
            oos_str_set(p, &content->storageClass,node_content);
         }
        entity = mxmlFindElement(node, tree,"Initiated",NULL, NULL,MXML_DESCEND);
        if(NULL != entity && NULL != entity->child){
            node_content = entity->child->value.opaque;
            oos_str_set(p, &content->initiated,node_content);
        }
        entity = mxmlFindElement(node, tree, "Initiator",NULL, NULL,MXML_DESCEND);
        if(NULL != entity && NULL != entity->child){
            mxml_node_t *initiator;
            initiator = mxmlFindElement(entity, tree, "ID",NULL, NULL,MXML_DESCEND);
            if(NULL != initiator && NULL != initiator->child){
                node_content = initiator->child->value.opaque;
                oos_str_set(p, &content->initiator_id,node_content);
            }
            initiator = mxmlFindElement(entity, tree, "DisplayName",NULL, NULL,MXML_DESCEND);
            if(NULL != initiator && NULL != initiator->child){
                node_content = initiator->child->value.opaque;
                oos_str_set(p, &content->initiator_displayName,node_content);
            }
        }
        entity = mxmlFindElement(node, tree, "Owner",NULL, NULL,MXML_DESCEND);
        if(NULL != entity && NULL != entity->child){
            mxml_node_t *owner;
            owner = mxmlFindElement(entity, tree, "ID",NULL, NULL,MXML_DESCEND);
            if(NULL != owner && NULL != owner->child){
                node_content = owner->child->value.opaque;
                oos_str_set(p, &content->owner_id,node_content);
            } 
            owner = mxmlFindElement(entity, tree, "DisplayName",NULL, NULL,MXML_DESCEND);
            if(NULL != owner && NULL != owner->child){
                node_content = owner->child->value.opaque;
                oos_str_set(p, &content->owner_displayName,node_content);
            }
        }

        INIT_LIST_HEAD(&content->node);
        list_add_tail(&content->node, list_upload->root);
     }

	 for (node = mxmlFindElement(tree, tree, "CommonPrefixes", NULL, NULL,
		 MXML_DESCEND); node != NULL; node = mxmlFindElement(node, tree,
			 "CommonPrefixes", NULL, NULL, MXML_DESCEND)) {
		 mxml_node_t *entity;
		 prefix = oos_pcalloc(p, sizeof(*prefix));

		 if (NULL == node || node->child == NULL) {
			 continue;
		 }
		 entity = mxmlFindElement(node, tree, "Prefix", NULL, NULL, MXML_DESCEND);
		 if (NULL != entity && NULL != entity->child) {
			 node_content = entity->child->value.opaque;
			 oos_str_set(p, &prefix->prefix, node_content);
		 }
		 INIT_LIST_HEAD(&prefix->node);
		 list_add_tail(&prefix->node, list_upload->prefix_root);
	 }
   
    // struct list_head *pos; 
    // list_for_each(pos, list_upload->root){
    //  oos_list_multipart_uploads_content_t* temp = list_entry(pos,struct oos_list_multipart_uploads_content_t,node);
    //  printf("0000000 id %s\n", temp->uploadId.data);
    // }
    mxmlDelete(tree);
    return list_upload;
}

part_listing_t* oos_list_parts_parse_from_body(oos_pool_t *p, const char* body){
    mxml_node_t *tree;
    tree = mxmlLoadString(NULL, body, MXML_OPAQUE_CALLBACK);
    mxml_node_t *node;
    part_listing_t* listing;
    listing = oos_pcalloc(p, sizeof(*listing)); 
    node = mxmlFindElement(tree, tree,"ListPartsResult",NULL, NULL,MXML_DESCEND);
    if(NULL == node || node->child == NULL)
        return NULL;
    listing->root = oos_pcalloc(p, sizeof(*listing->root));
    INIT_LIST_HEAD(listing->root);
    part_summary_t* content;
    char *node_content=NULL;

    mxml_node_t *entity;
    entity = mxmlFindElement(node, tree,"Bucket",NULL, NULL,MXML_DESCEND);
    if(NULL != entity && NULL != entity->child){
        node_content = entity->child->value.opaque;
        oos_str_set(p, &listing->bucket, node_content);
    }
    entity = mxmlFindElement(node, tree,"Key",NULL, NULL,MXML_DESCEND);
    if(NULL != entity && NULL != entity->child){
        node_content = entity->child->value.opaque;
        oos_str_set(p, &listing->key, node_content);
    }
    entity = mxmlFindElement(node, tree,"UploadId",NULL, NULL,MXML_DESCEND);
    if(NULL != entity && NULL != entity->child){
        node_content = entity->child->value.opaque;
        oos_str_set(p, &listing->uploadId, node_content);
    }
    entity = mxmlFindElement(node, tree,"StorageClass",NULL, NULL,MXML_DESCEND);
    if(NULL != entity && NULL != entity->child){
        node_content = entity->child->value.opaque;
        oos_str_set(p, &listing->storageClass, node_content);
    }
    entity = mxmlFindElement(node, tree,"MaxParts",NULL, NULL,MXML_DESCEND);
    if(NULL != entity && NULL != entity->child){
        node_content = entity->child->value.opaque;
        listing->maxParts = atoi(node_content);
    }
    entity = mxmlFindElement(node, tree,"IsTruncated",NULL, NULL,MXML_DESCEND);
    if(NULL != entity && NULL != entity->child){
        node_content = entity->child->value.opaque;
        oos_str_set(p, &listing->isTruncated, node_content);
    }

    entity = mxmlFindElement(node, tree, "Initiator",NULL, NULL,MXML_DESCEND);
    if(NULL != entity && NULL != entity->child){
        mxml_node_t *initiator;
        initiator = mxmlFindElement(entity, tree, "ID",NULL, NULL,MXML_DESCEND);
        if(NULL != initiator && NULL != initiator->child){
            node_content = initiator->child->value.opaque;
            oos_str_set(p, &listing->initiator_id,node_content);
        }
        initiator = mxmlFindElement(entity, tree, "DisplayName",NULL, NULL,MXML_DESCEND);
        if(NULL != initiator && NULL != initiator->child){
            node_content = initiator->child->value.opaque;
            oos_str_set(p, &listing->initiator_displayName,node_content);
        }
    }
    entity = mxmlFindElement(node, tree, "Owner",NULL, NULL,MXML_DESCEND);
    if(NULL != entity && NULL != entity->child){
        mxml_node_t *owner;
        owner = mxmlFindElement(entity, tree, "ID",NULL, NULL,MXML_DESCEND);
        if(NULL != owner && NULL != owner->child){
            node_content = owner->child->value.opaque;
            oos_str_set(p, &listing->owner_id,node_content);
        } 
        owner = mxmlFindElement(entity, tree, "DisplayName",NULL, NULL,MXML_DESCEND);
        if(NULL != owner && NULL != owner->child){
            node_content = owner->child->value.opaque;
            oos_str_set(p, &listing->owner_displayName,node_content);
        }
    }

    for (node = mxmlFindElement(node, tree,"Part",NULL, NULL,
                MXML_DESCEND);node != NULL;node = mxmlFindElement(node, tree,
                "Part",NULL, NULL,MXML_DESCEND)){
        content = oos_pcalloc(p, sizeof(*content));
        entity = mxmlFindElement(node, tree,"PartNumber",NULL, NULL,MXML_DESCEND);
        if(NULL != entity && NULL != entity->child){
            node_content = entity->child->value.opaque;
            content->partNumber = atoi(node_content);
        }
        entity = mxmlFindElement(node, tree,"LastModified",NULL, NULL,MXML_DESCEND);
        if(NULL != entity && NULL != entity->child){
            node_content = entity->child->value.opaque;
            oos_str_set(p, &content->lastModified, node_content);
        }
        entity = mxmlFindElement(node, tree,"ETag",NULL, NULL,MXML_DESCEND);
        if(NULL != entity && NULL != entity->child){
            node_content = entity->child->value.opaque;
            oos_str_set(p, &content->eTag, node_content);
        }
        entity = mxmlFindElement(node, tree,"Size",NULL, NULL,MXML_DESCEND);
        if(NULL != entity && NULL != entity->child){
            node_content = entity->child->value.opaque;
            content->size = atoi(node_content);
        }
        INIT_LIST_HEAD(&content->node);
        list_add_tail(&content->node, listing->root);
    }
    mxmlDelete(tree);
    return listing;
}

copy_object_result_t* oos_copy_object_parse_from_body(oos_pool_t *p, const char* body){
    copy_object_result_t* result ;
    result = oos_pcalloc(p,sizeof(*result));
    mxml_node_t *tree;
    char *node_content=NULL;
    tree = mxmlLoadString(NULL, body, MXML_OPAQUE_CALLBACK);
    if(NULL == tree || NULL == tree->child){
        return NULL;//do nothing
    }

    tree = mxmlFindElement(tree, tree,"ETag",NULL, NULL,MXML_DESCEND);
    if(NULL != tree && NULL != tree->child){
        node_content = tree->child->value.opaque;
        oos_str_set(p, &result->etag, node_content);
        printf("-------- etag %s\n", result->etag.data);
    }
    tree = mxmlFindElement(tree, tree,"LastModified",NULL, NULL,MXML_DESCEND);
    if(NULL != tree && NULL != tree->child){
        node_content = tree->child->value.opaque;
        oos_str_set(p, &result->lastModifiedDate, node_content);
        printf("-------- lastModifiedDate %s\n", result->lastModifiedDate.data);
    }
    mxmlDelete(tree);
    return result;
}

