
#ifndef __OOS_XML_H__
#define __OOS_XML_H__

#include "oos_api.h"
#include "response.h"

void oos_delete_result_parse_from_body(oos_pool_t *p, const char* body, delete_multiple_list_t* list);

oos_list_object_t* oos_list_objects_parse_from_body(oos_pool_t *p, const char* body);

oos_list_bucket_t* oos_list_bucket_parse_from_body(oos_pool_t *p,const char* body);

oos_list_access_key_t* oos_list_access_parse_from_body(oos_pool_t *p, const char* body);

void oos_parse_err_resp(response* resp);

lifecycle_configuration_t* oos_get_bucket_lifecycle_parse_from_body(oos_pool_t *p,const char* body);

cors_configuration_t* oos_get_cors_parse_from_body(oos_pool_t *p,const char* body);

accelerate_configuration_t* oos_get_bucket_accelerate_parse_from_body(oos_pool_t *p,const char* body);

region_configuration_t* oos_get_region_parse_from_body(oos_pool_t *p,const char* body);

location_configuration_t* oos_get_bucket_location_parse_from_body(oos_pool_t *p,const char* body);

acl_configuration_t* oos_get_bucket_acl_parse_from_body(oos_pool_t *p,const char* body);

website_configuration_t*  oos_get_bucket_website_parse_from_body(oos_pool_t *p,const char* body);

logging_configuration_t* oos_get_bucket_logging_parse_from_body(oos_pool_t *p, const char* body);

trigger_configuration_t* oos_get_bucket_trigger_parse_from_body(oos_pool_t *p, const char* body);

oos_list_access_key_member_t* oos_create_access_key_parse_from_body(oos_pool_t *p,const char* body);

initiate_multipart_upload_result_t* oos_multipart_uploadId_parse_from_body(oos_pool_t *p,const char* body);

oos_list_multipart_uploads_t* oos_list_multipart_upload_parse_from_body(oos_pool_t *p,const char* body);

part_listing_t* oos_list_parts_parse_from_body(oos_pool_t *p,const char* body);

copy_object_result_t* oos_copy_object_parse_from_body(oos_pool_t *p, const char* body);

#endif
